;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   CSA_EMC.inc
;;   Version: 1.50, Updated on 2013/5/19 at 10:42:39
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION:
;;    Assembler declarations for the CSA_EMC user module interface
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************
include "GlobalParams.inc"

; Determine whether the wizard was called after place, rename or update operation
CSA_EMC_WIZARD_PROCESSED:                  equ 1
IF CSA_EMC_WIZARD_PROCESSED^1
"Wizard_was_not_called_after_place_rename_configuration_change_or_update_Open_Chip_Editor_open_Wizard_press_OK_button_and_generate_project"
ENDIF

CSA_EMC_INT_MSK_REG:                             equ e0h ; INT_MSK register address
CSA_EMC_INT_CLR_REG:                             equ dah ; INT_CLR register address
CSA_EMC_INT_MASK:                                equ 04h ; CapSense Mask bit

CSA_EMC_IMO_24MHz:                               equ 02h
CSA_EMC_IMO_12MHz:                               equ 00h
CSA_EMC_IMO_6MHz:                                equ 01h

IF (1h)  ; CY8C20X24
IMO_SETTING:                                     equ 00h ; 4 usec delay
ENDIF

IF (IMO_SETTING & CSA_EMC_IMO_24MHz)
CSA_EMC_DISCHARGE_DELAY:                         equ 04h ; 4 usec delay
ELSE
	IF (IMO_SETTING & CSA_EMC_IMO_6MHz)
	CSA_EMC_DISCHARGE_DELAY:                     equ 00h ; 4 usec delay
	ELSE
	CSA_EMC_DISCHARGE_DELAY:                     equ 01h ; 4 usec delay
	ENDIF
ENDIF


;--------------------------------------------------
; Constants for CSA_EMC API's
;--------------------------------------------------

CSA_EMC_SCAN_ACTIVE:                             equ 10h ; Set when scanning is active
CSA_EMC_OVERFLOW:                                equ 01h ; Set when rebaseline is needed

CSA_EMC_ButtonCount:                             equ 9h
CSA_EMC_SliderCount:                             equ 0h  + 0h
CSA_EMC_TotalSensorCount:                        equ 9h
CSA_EMC_SettlingTime:                            equ a0h
CSA_EMC_Debounce:                                equ 3h
CSA_EMC_LowBaselineReset:                        equ 32h

CSA_EMC_BUTTONS_EXIST:                           equ 9h
CSA_EMC_SLIDERS_EXIST:                           equ 0h | 0h

CSA_EMC_EXTERNAL_CAP:                            equ 2h
CSA_EMC_HYSTERESIS:                              equ ah
CSA_EMC_CLOCK:                                   equ 80h | (2 << 5)
CSA_EMC_AUTORESET:                               equ 0

CSA_EMC_DiplexUsed:                    equ 0

CSA_EMC_FINGER_THRESHOLD:                        equ 82h
CSA_EMC_NOISE_THRESHOLD:                         equ 28h
CSA_EMC_NEGATIVE_NOISE_THRESHOLD:                equ 14h
CSA_EMC_BASELINE_UPDATE_THRESHOLD:               equ 96h

CSA_EMC_IMMUNITY_LEVEL:                          equ 1h
CSA_EMC_FREQ_NUM:                                equ 1h
CSA_EMC_PRS:                                     equ 0h
CSA_EMC_SEED:                                    equ 0ch
CSA_EMC_POLYNOMIAL:                              equ 60h

CSA_EMC_BASELINE:                                equ 800h

IF (CSA_EMC_EXTERNAL_CAP)
CSA_EMC_IDAC_RANGE:                              equ 50h  ; 2x
ELSE
CSA_EMC_IDAC_RANGE:                              equ 10h  ; 1x
ENDIF

CSA_EMC_RAW_MEDIAN_ENABLE:                       equ 0h
CSA_EMC_RAW_IIR_ENABLE:                          equ 0h
CSA_EMC_RAW_IIR_COEFF:                           equ 2h

;--------------------------------------------------
; Registers Address Constants for CSA_EMC
;--------------------------------------------------

CSA_EMC_CapSense_CR0_REG:                        equ a0h              ; CS_CR0 Reg
CSA_EMC_CapSense_CR1_REG:                        equ a1h              ; CS_CR1 Reg
CSA_EMC_CapSense_CR2_REG:                        equ a2h              ; CS_CR2 Reg
CSA_EMC_CapSense_CR3_REG:                        equ a3h              ; CS_CR3 Reg
CSA_EMC_CapSense_CNTH_REG:                       equ a5h              ;
CSA_EMC_CapSense_CNTL_REG:                       equ a4h              ;
CSA_EMC_CapSense_STAT_REG:                       equ a6h              ;
CSA_EMC_CapSense_SLEW_REG:                       equ a8h              ;
CSA_EMC_CapSense_TIMER_REG:                      equ a7h              ;
CSA_EMC_CMP_CR0_REG:                             equ 7ah              ; CMP_CR0 Reg
CSA_EMC_CMP_CR1_REG:                             equ 7bh              ; CMP_CR1 Reg
CSA_EMC_CMP_MUX_REG:                             equ 79h              ; CMP_MUX Reg

CSA_EMC_AMUX_CFG_REG:                  equ AMUX_CFG        ; Analog Mux Configuration Register

DR_OFFSET:                                       equ 00h
DM0_OFFSET:                                      equ 00h              ; Bank 1
DM1_OFFSET:                                      equ 01h              ; Bank 1
MUX_OFFSET:                                      equ MUX_CR0          ; Bank 1

;--------------------------------------------------
; CSA_EMC Macro 'Functions'
;--------------------------------------------------

   macro CSA_EMC_EnableInt_M
   M8C_EnableIntMask CSA_EMC_INT_MSK_REG, CSA_EMC_INT_MASK
   endm

   macro CSA_EMC_DisableInt_M
   M8C_DisableIntMask CSA_EMC_INT_MSK_REG, CSA_EMC_INT_MASK
   endm

; end of file CSA_EMC.inc
