;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: CSA_EMC.asm
;;   Version: 1.50, Updated on 2013/5/19 at 10:42:39
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: CSA_EMC User Module software implementation file
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "CSA_EMC.inc"

;-----------------------------------------------
;  Global Labels
;-----------------------------------------------

; Exported functions
export _CSA_EMC_Start
export  CSA_EMC_Start
export _CSA_EMC_Stop
export  CSA_EMC_Stop
export _CSA_EMC_Resume
export  CSA_EMC_Resume
export _CSA_EMC_ClearSensors
export  CSA_EMC_ClearSensors
export _CSA_EMC_wReadSensor
export  CSA_EMC_wReadSensor
export _CSA_EMC_wGetPortPin
export  CSA_EMC_wGetPortPin
export _CSA_EMC_EnableSensor
export  CSA_EMC_EnableSensor
export _CSA_EMC_DisableSensor
export  CSA_EMC_DisableSensor
export   ScanSingleSensor
export _CSA_EMC_ScanSingleSensor
export  CSA_EMC_ScanSingleSensor
export _CSA_EMC_ScanSensor
export  CSA_EMC_ScanSensor
export _CSA_EMC_ScanAllSensors
export  CSA_EMC_ScanAllSensors
export CopyIdacValue
export _CSA_EMC_CopyIdacValue
export  CSA_EMC_CopyIdacValue
export _CSA_EMC_Calibrate
export  CSA_EMC_Calibrate
export _CSA_EMC_CalibrateSingleSensor
export  CSA_EMC_CalibrateSingleSensor
export _CSA_EMC_CalibrateAllSensors
export  CSA_EMC_CalibrateAllSensors

; Exported variables
export  CSA_EMC_bfStatus
export _CSA_EMC_bfStatus
export  bSensorNum
export  CSA_EMC_bSensorNum
export _CSA_EMC_bSensorNum
export  CSA_EMC_baDACCodeBaseline
export _CSA_EMC_baDACCodeBaseline
export   wADCResult
export  CSA_EMC_wADCResult
export _CSA_EMC_wADCResult

;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)
export  TotalSensorCount
export _CSA_EMC_baDAC
export  CSA_EMC_baDAC
export _CSA_EMC_bIDACSetting
export  CSA_EMC_bIDACSetting
export _CSA_EMC_bSettlingTime
export  CSA_EMC_bSettlingTime
export  bFreq
export  _bFreq
export  CSA_EMC_bFreq

_CSA_EMC_baDAC:
 CSA_EMC_baDAC:                         BLK  (CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)
_CSA_EMC_bIdacValue:
 CSA_EMC_bIdacValue:
_CSA_EMC_bIDACSetting:
 CSA_EMC_bIDACSetting:                  BLK  1 
_CSA_EMC_bSettlingTime:
 CSA_EMC_bSettlingTime:                 BLK  1
 
 CSA_EMC_bBitMask:                      BLK  1  ; Temp bitmask byte
_CSA_EMC_bfStatus:                              ; Status byte
 CSA_EMC_bfStatus:                      BLK  1
  bSensorNum:
_CSA_EMC_bSensorNum:                            ; Current sensor to scan
 CSA_EMC_bSensorNum:                    BLK  1
_CSA_EMC_bScanWeight:                           ; SA helper variable
 CSA_EMC_bScanWeight:                   BLK  1
_CSA_EMC_bTempDACD:                             ; SA helper variable
 CSA_EMC_bTempDACD:                     BLK  1
 
 TotalSensorCount: 
_TotalSensorCount:                      BLK  1 
 bFreq:
 _bFreq:
 CSA_EMC_bFreq:                         BLK  CSA_EMC_IMMUNITY_LEVEL
  wADCResult:
_CSA_EMC_wADCResult:
 CSA_EMC_wADCResult:                    BLK  2

IF (CSA_EMC_PRS)
   bLFSR:
 _CSA_EMC_bLFSR:
  CSA_EMC_bLFSR:                        BLK  1
  
  export  bLFSR
  export _CSA_EMC_bLFSR
  export  CSA_EMC_bLFSR
ENDIF

AREA bss
_CSA_EMC_baDACCodeBaseline:                     ; DAC Code found with SA
 CSA_EMC_baDACCodeBaseline:             BLK  CSA_EMC_TotalSensorCount

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; User Includes
;------------------------


;------------------------
; User Constant Definitions
;------------------------


;------------------------
; User Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)

;------------------------
;  Constant Definitions
;------------------------

AREA UserModules (ROM, REL, CON)

LSB:  equ  1
MSB:  equ  0

.LITERAL

CSA_EMC_MUX_Table:                                  ; Analog Mux Enables Register address
  db    MUX_CR0, MUX_CR1, MUX_CR2, MUX_CR3, DFh

.ENDLITERAL


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_Start(void)
;
;  DESCRIPTION:
;  Connects external cap; sets up comparator
;  disables all possible analog mux bus
;  connections; shunts all sensor pins to ground.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    None
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_Start:
_CSA_EMC_Start:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   RAM_SETPAGE_IDX >CSA_EMC_baSnsOnMask
   mov   X, (CSA_EMC_TotalSensorCount-1)/8
.NullingCycle:
   mov   [X + <CSA_EMC_baSnsOnMask], 0
   dec   X
   jnc   .NullingCycle
   
   RAM_SETPAGE_IDX >CSA_EMC_baLowBaselineReset
   mov   X, (CSA_EMC_TotalSensorCount - 1)
.InitCycle:
   mov   [X + CSA_EMC_baSnsDebounce], CSA_EMC_Debounce
   mov   [X + <CSA_EMC_baLowBaselineReset], CSA_EMC_LowBaselineReset
   dec   X
   jnc   .InitCycle

   mov   [CSA_EMC_bNoiseThreshold], CSA_EMC_NOISE_THRESHOLD
   mov   [CSA_EMC_bNegativeNoiseThreshold], CSA_EMC_NEGATIVE_NOISE_THRESHOLD
   mov   [CSA_EMC_bBaselineUpdateThreshold], CSA_EMC_BASELINE_UPDATE_THRESHOLD
   mov   [CSA_EMC_bHysteresis], CSA_EMC_HYSTERESIS
   mov   [CSA_EMC_bDebounce], CSA_EMC_Debounce
   mov   [CSA_EMC_bLowBaselineReset], CSA_EMC_LowBaselineReset
   mov   [CSA_EMC_bSettlingTime], CSA_EMC_SettlingTime
   mov   [TotalSensorCount], CSA_EMC_TotalSensorCount  
IF (CSA_EMC_PRS)
   mov   [CSA_EMC_bLFSR], CSA_EMC_SEED
ENDIF

IF (CSA_EMC_IMMUNITY_LEVEL / 3)
   lcall SetImmunityHigh
ENDIF

   call  CSA_EMC_Resume
   call  CSA_EMC_ClearSensors                         ; Loop through all sensors and deactivates them
                                                          ; This sets the pin to the proper drive mode (strong low).
   mov   A, (CSA_EMC_TotalSensorCount - 1)            ; Loop through to do Successive Approximation on the DAC current
.InitLoop:
   push  A
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_EnableSensor
   call  CSA_EMC_bFindDACCodeBaseline
   pop   X
   RAM_SETPAGE_IDX >CSA_EMC_baDACCodeBaseline
   mov   [X+CSA_EMC_baDACCodeBaseline],A
   push  X
   mov   A,X
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_DisableSensor
   pop   A
   dec   A
   jnc   .InitLoop
   
   RAM_EPILOGUE RAM_USE_CLASS_3
   mov   A, <CSA_EMC_BASELINE
   mov   X, >CSA_EMC_BASELINE
   call  CSA_EMC_Calibrate
   RAM_EPILOGUE RAM_USE_CLASS_4   
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_bFindDACCodeBaseline(void)
;
;  DESCRIPTION:
;  Performs successive apporiximation to find the DAC setting that results
;  in a voltage closest to the reference
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      DAC code for the currently enabled sensor via Successive Aprox
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_bFindDACCodeBaseline:
_CSA_EMC_bFindDACCodeBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

IF (CSA_EMC_IMMUNITY_LEVEL / 3)
   lcall ConfigureHigh
ENDIF
   ; Set scan weight to initial state
   mov [CSA_EMC_bScanWeight], 80h
   ; Start current at mid value
   mov reg[IDAC_D], 80h
   mov [CSA_EMC_bTempDACD], 80h

.SARLoop:
   or reg[CSA_EMC_CapSense_CR0_REG], 01h                             ; Enable the CapSense block, starts the switching circuitry

   mov a, [CSA_EMC_bSettlingTime]                                    ; Settling time
.DelayLoop:
   nop
   nop
   nop
   dec a
   jnc .DelayLoop

   tst reg[CMP_RDC], 10h                                             ; Check if comparator is high
   jz .KeepBit
.ClearBit:
   mov a, [CSA_EMC_bScanWeight]
   cpl a
   and [CSA_EMC_bTempDACD], a
.KeepBit:
   and reg[CSA_EMC_CapSense_CR0_REG], ~01h                           ; Disable Capsense block
   and F, ~04h ; Clear carry bit
   rrc [CSA_EMC_bScanWeight]
   jc .EndSARStep
   mov    a, [CSA_EMC_bScanWeight]
   or [CSA_EMC_bTempDACD], a
   mov a, [CSA_EMC_bTempDACD]
   mov reg[IDAC_D], a                                                ; Update DAC register to new value
   jmp .SARLoop
.EndSARStep:

IF (CSA_EMC_IMMUNITY_LEVEL / 3)
   lcall RestoreNormalScan
ENDIF

   mov   A, [CSA_EMC_bTempDACD]
   mov   reg[IDAC_D], A                                              ; Return DAC register value

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMCCalibrate(wLevel)
;
;  DESCRIPTION:
;  Performs successive apporiximation to find the DAC setting that results
;  in a reasult closest to the wLevel value
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A - wLevel (LSB)
;                X - wLevel (MSB)
;  RETURNS:      None. Calibration setting are stored in the global variable CSA_EMC_bIDACSetting
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_Calibrate:
_CSA_EMC_Calibrate:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   mov   [CSA_EMC_bTempDACD], A                                           ; LSB
   mov   [CSA_EMC_bBitMask], X                                            ; MSB
   or    reg[CMP_MUX], 2h

   ; Set scan weight to initial state
   mov   [CSA_EMC_bScanWeight], 80h
   ; Start current at mid value
   mov   [CSA_EMC_bIDACSetting], 80h

.SARLoop:
   or    reg[CSA_EMC_CapSense_CR3_REG], 70h                               ; Preset the voltage for quicker settling

   mov   A, [CSA_EMC_bSettlingTime]                                  ; Settling time
.DelayLoop:
   dec   A
   jnc   .DelayLoop

   mov   A, [CSA_EMC_bIDACSetting]
   mov   reg[IDAC_D], A
   and   reg[CSA_EMC_CapSense_CR3_REG], ~70h

   mov   reg[CSA_EMC_CapSense_CR2_REG], 00h                               ; Disable the IDAC
   mov   reg[CSA_EMC_CapSense_CR1_REG], 80h                               ; Ramp should be clocked at IMO
   or    reg[CSA_EMC_CapSense_CR0_REG], 01h                               ; Enable the Counter
   mov   reg[CSA_EMC_CapSense_CR2_REG], CSA_EMC_IDAC_RANGE                ; Enable the IDAC
   mov   reg[CSA_EMC_INT_CLR_REG], ~CSA_EMC_INT_MASK
   or    [CSA_EMC_bfStatus], CSA_EMC_SCAN_ACTIVE                          ; Set scan active flag
   CSA_EMC_EnableInt_M                                                    ; Enable the CapSense interrupt

.waitforinterrupt:
   tst   [CSA_EMC_bfStatus], CSA_EMC_SCAN_ACTIVE                          ; Set scan active flag
   jnz   .waitforinterrupt

   CSA_EMC_DisableInt_M

   tst   reg[CSA_EMC_CapSense_STAT_REG], 20h                              ; Check for overflow
   jnz   .KeepBit

   mov   A, reg[CS_CNTL]                                                  ; If Result >= wLevel
   cmp   A, [CSA_EMC_bTempDACD]                                           ; then increase iDAC
   mov   A, reg[CS_CNTH]
   sbb   A, [CSA_EMC_bBitMask]
   jnc   .KeepBit

.ClearBit:
   mov   A, [CSA_EMC_bScanWeight]
   cpl   A
   and   [CSA_EMC_bIDACSetting], A
.KeepBit:
   and   reg[CSA_EMC_CapSense_STAT_REG], ~20h                             ; Clear overflow
   and   reg[CSA_EMC_CapSense_CR0_REG], ~01h                              ; Disable the CapSense block
   and   F, ~04h ; Clear carry bit
   rrc   [CSA_EMC_bScanWeight]
   jc    .EndSARStep
   mov   A, [CSA_EMC_bScanWeight]
   or    [CSA_EMC_bIDACSetting], A
   jmp   .SARLoop
.EndSARStep:

   cmp   [CSA_EMC_bIDACSetting], 0
   jnz   .Done
   inc   [CSA_EMC_bIDACSetting]
.Done:
   and   reg[CMP_MUX], ~2h
   
   RAM_PROLOGUE RAM_USE_CLASS_3
   mov   X, ((CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)-1)
   mov   A, [CSA_EMC_bIDACSetting]
   RAM_SETPAGE_IDX >CSA_EMC_baDAC   
.InitDACs:   
   mov   [X + CSA_EMC_baDAC], A
   dec   X  ; NextSensor
   jnc   .InitDACs   
   RAM_EPILOGUE RAM_USE_CLASS_3  
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_CalibrateAllSensors(wLevel)
;
;  DESCRIPTION:
;  Performs successive apporiximation to find the DAC setting that results
;  in a reasult closest to the wLevel value
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A - wLevel (LSB)
;                X - wLevel (MSB)
;  RETURNS:      None. Calibration setting are stored in the global variable CSA_EMC_bIDACSetting
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_CalibrateAllSensors:
_CSA_EMC_CalibrateAllSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   mov   [CSA_EMC_bSensorNum], (CSA_EMC_TotalSensorCount-1) 
.NextSensor:
   push  X  ; wLevel (MSB) -> Stack
   push  A  ; wLevel (LSB) -> Stack
   mov   A, [CSA_EMC_bSensorNum]   ; bSensor 
   push  A  ; bSensor -> Stack 
   call  CSA_EMC_CalibrateSingleSensor
   pop   A  ; Get bSensor    
   pop   A  ; Get wLevel (LSB)   
   pop   X  ; Get wLevel (MSB)
   dec   [CSA_EMC_bSensorNum]  ; NextSensor
   jnc   .NextSensor
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_CalibrateSingleSensor(BYTE bSensor, WORD CalibratedRawCountLevel)
;
;  DESCRIPTION:
;  Performs successive apporiximation to find the DAC setting that results
;  in a reasult closest to the wLevel value
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    
;   [X - 3]  =>  bSensor
;   [X - 4]  =>  CalibratedRawCountLevelLSB
;   [X - 5]  =>  CalibratedRawCountLevelMSB  
;  RETURNS:      None. Calibration setting are stored in the global variable CSA_EMC_bIDACSetting
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
; Stack offset constants
SENSOR_ID:     equ  -3   ; Stack position for bSensor    
CAL_LEVER_LSB: equ  -4   ; Stack position for CalibratedRawCountLevel LSB.   
CAL_LEVER_MSB: equ  -5   ; Stack position for CalibratedRawCountLevel MSB. 

 CSA_EMC_CalibrateSingleSensor:
_CSA_EMC_CalibrateSingleSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_PROLOGUE RAM_USE_CLASS_2
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area   
   mov   X, SP
IF (CSA_EMC_IMMUNITY_LEVEL / 3)   
   mov   [CSA_EMC_bCurPos], 2
   mov   A, [X + SENSOR_ID] 
   mov   [CSA_EMC_bSensorNum], A 
   add   A, CSA_EMC_TotalSensorCount*2
   mov   [X + SENSOR_ID], A
   RAM_EPILOGUE RAM_USE_CLASS_2
.NextFreq:
   RAM_PROLOGUE RAM_USE_CLASS_3   
   push  A
   M8C_SetBank1
   mov   X, [CSA_EMC_bCurPos]
   mov   A, [X + CSA_EMC_bFreq]
   mov   reg[e8h], A
   M8C_SetBank0   
   pop   X   
ELSE   
   mov   X, [X + SENSOR_ID]
   mov   [CSA_EMC_bSensorNum], X   
   RAM_EPILOGUE RAM_USE_CLASS_2
   RAM_PROLOGUE RAM_USE_CLASS_3   
ENDIF
   
   
   ; Set scan weight to initial state
   mov   [CSA_EMC_bCalMask], 80h
   ; Start current at mid value
   ;mov   [CSA_EMC_bSensorNum], X
   RAM_SETPAGE_IDX >CSA_EMC_baDAC   
   mov   [X + CSA_EMC_baDAC], 80h

.SARLoop:
   RAM_EPILOGUE RAM_USE_CLASS_3
   mov   A, X
   call  CSA_EMC_CopyIdacValue
   mov   A, [CSA_EMC_bSensorNum]
   call  CSA_EMC_ScanSingleSensor  

   RAM_PROLOGUE RAM_USE_CLASS_2  
   mov   X, SP
   mov   A, [CSA_EMC_wADCResult+LSB]                                      ; If Result >= wLevel
   cmp   A, [X + CAL_LEVER_LSB]                                           ; then increase iDAC
   mov   A, [CSA_EMC_wADCResult+MSB]
   sbb   A, [X + CAL_LEVER_MSB]
   mov   X, [X + SENSOR_ID]
   RAM_EPILOGUE RAM_USE_CLASS_2   
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >CSA_EMC_baDAC  
   jnc   .KeepBit

.ClearBit:
   mov   A, [CSA_EMC_bCalMask]
   cpl   A
   and   [X + CSA_EMC_baDAC], A
.KeepBit:
   and   F, ~04h ; Clear carry bit
   rrc   [CSA_EMC_bCalMask]
   jc    .EndSARStep
   mov   A, [CSA_EMC_bCalMask]
   or    [X + CSA_EMC_baDAC], A   
   jmp   .SARLoop
.EndSARStep:

   cmp   [X + CSA_EMC_baDAC], 0
   jnz   .Done
   inc   [X + CSA_EMC_baDAC]
.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
IF (CSA_EMC_IMMUNITY_LEVEL / 3)
   RAM_PROLOGUE RAM_USE_CLASS_2
   mov   A, X
   sub   A, CSA_EMC_TotalSensorCount
   mov   X, SP  
   mov   [X + SENSOR_ID], A
   RAM_EPILOGUE RAM_USE_CLASS_2   
   dec   [CSA_EMC_bCurPos]
   jnc   .NextFreq   
ENDIF
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_ClearSensors(void)
;
;  DESCRIPTION:
;    Clears all sensor connections to the analog mux bus and shunts all sensor
;    pins to ground.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_ClearSensors:
_CSA_EMC_ClearSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   A, (CSA_EMC_TotalSensorCount - 1)            ; Check if key value in range.
.InitLoop:                                            ; Loop through all sensors and deactivate
   push  A
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_DisableSensor
   pop   A
   dec   A
   jnc   .InitLoop
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_Stop(void)
;
;  DESCRIPTION:
;  Disables RO interrupt; disables the relaxation oscillator circuitry;
;  clears scan active flag; disables all sensors and shunts them to ground.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_Stop:
_CSA_EMC_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   CSA_EMC_DisableInt_M                                              ; Disable scanner interrupts
   and   reg[CSA_EMC_CapSense_CR0_REG], ~(01h)                       ; Disable Capsense block
   and   [CSA_EMC_bfStatus],~(CSA_EMC_SCAN_ACTIVE)                   ; Clear scan active flag
   call  CSA_EMC_ClearSensors                                        ; Loop through all keys and deactivate
   and   reg[CMP_CR0], ~01h                                          ; Disable the Comparator
   mov   reg[CSA_EMC_AMUX_CFG_REG], 0                                              ; Disable external cap

   IF(CSA_EMC_EXTERNAL_CAP & 01h)
   mov   X, 00h
   mov   A, 02h
   call CSA_EMC_DisableSensor
   ENDIF

   IF(CSA_EMC_EXTERNAL_CAP & 02h)
   mov   X, 00h
   mov   A, 08h
   call CSA_EMC_DisableSensor
   ENDIF
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_Resume(void)
;
;  DESCRIPTION:
;
;    Resumes CSD operation after Stop() call
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_Resume:
_CSA_EMC_Resume:
   RAM_PROLOGUE RAM_USE_CLASS_4

IF (CSA_EMC_EXTERNAL_CAP)
   mov   reg[CSA_EMC_AMUX_CFG_REG], CSA_EMC_EXTERNAL_CAP  ; Enable external cap
ELSE
   mov   reg[CSA_EMC_AMUX_CFG_REG], 0Ch   
ENDIF   
   or    reg[CMP_CR0], 01h                                  ; Enable the Comparator

   IF(CSA_EMC_EXTERNAL_CAP & 01h)
   or    reg[CMP_MUX], 08h                            ; Connect comparator to external cap
   mov   X, 00h
   mov   A, 02h
   call  CSA_EMC_EnableSensor
   ENDIF

   IF(CSA_EMC_EXTERNAL_CAP & 02h)
   or    reg[CMP_MUX], 0Ch                            ; Connect comparator to external cap
   mov   X, 00h
   mov   A, 08h
   call  CSA_EMC_EnableSensor
   ENDIF   
   
   
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.LITERAL
 CSA_EMC_Sensor_Table2:
_CSA_EMC_Sensor_Table2:
IF (CSA_EMC_TotalSensorCount)
  	dw	0x0108	// Port 1 Bit 3
	dw	0x0308	// Port 3 Bit 3
	dw	0x0202	// Port 2 Bit 1
	dw	0x0208	// Port 2 Bit 3
	dw	0x0110	// Port 1 Bit 4
	dw	0x0010	// Port 0 Bit 4
	dw	0x0240	// Port 2 Bit 6
	dw	0x0204	// Port 2 Bit 2
	dw	0x0304	// Port 3 Bit 2

ELSE
  dw 0x00
ENDIF
.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_wGetPortPin(BYTE bSensor)
;
;  DESCRIPTION:
;      Returns the port and pin mask from a given sensor number.  This
;      function uses the table CSA_EMC_Sensor_Table to retrieve this
;      information.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;        A => Sensor Number  ( 0 to n )
;  RETURNS:
;        A  <=  Sensor Bitmap
;        X  <=  Port Number
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_wGetPortPin:
_CSA_EMC_wGetPortPin:
   RAM_PROLOGUE RAM_USE_CLASS_1

   asl   A                                       ; Multiply index by 2 since table is 2 bytes per sensor
   mov   X,A                                     ; Copy index*2 in x for next value
   index CSA_EMC_Sensor_Table2                   ; A contains the port value
   swap  A,X                                     ; Place port value in X and index*2 in A
   inc   A                                       ; Advance to next value (bitMask)
   index CSA_EMC_Sensor_Table2                   ; A contains bitMask, X has port number

   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_EnableSensor(BYTE bSensorMask, BYTE bPort)
;
;  DESCRIPTION:
;    Configures sensor to be an input to be measured during next measurement
;    cycle; places sensor pin's drive mode in Analog Hi-Z mode and connects
;    to the analog mux bus.
;
;    This function does not do anything with the previous sensor.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_EnableSensor:
_CSA_EMC_EnableSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   ; Setup Mux for sensor
   mov   [CSA_EMC_bBitMask],A                              ; Store bit mask in temp location
   push  X

   mov   A, X                                              ; Multiply port number by four for registor addresses
   asl   A
   asl   A
   mov   X, A                                              ; Restore Port address in X

   ; Set mode do 10 (Hi-Z Analog) and connect to analog mux bus
   M8C_SetBank1
   mov   A, reg[X+DM1_OFFSET]                              ; Set DM1 to 1
   or    A, [CSA_EMC_bBitMask]
   mov   reg[X+DM1_OFFSET], A
   xor   [CSA_EMC_bBitMask],FFh                            ; Invert bitmask
   mov   A, reg[X+DM0_OFFSET]                              ; Clear DM0 bit to 0
   and   A, [CSA_EMC_bBitMask]
   mov   reg[X+DM0_OFFSET], A
   xor   [CSA_EMC_bBitMask],FFh                            ; Invert bitmask to get original mask
   pop   A

   index CSA_EMC_MUX_Table
   mov   X, A
   mov   A, reg[X]
   or    A, [CSA_EMC_bBitMask]
   mov   reg[X], A
   M8C_SetBank0

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_DisableSensor(BYTE bMask, BYTE bPort)
;
;  DESCRIPTION:
;    Disconnects the desired sensor from the analog mux bus and shunts to
;    ground.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;          X =>  Port Number for given sensor
;          A =>  Bit mask for given sensor
;
;  RETURNS:      none
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_DisableSensor:
_CSA_EMC_DisableSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   ; Disconnect sensor from mux
   push  X                                       ; Store Port Number
   cpl   A                                       ; Invert bitmask
   mov   [CSA_EMC_bBitMask], A                   ; Store bit mask in temp location
   M8C_SetBank1
   mov   A, X
   index CSA_EMC_MUX_Table
   mov   X, A
   mov   A, reg[X]
   and   A, [CSA_EMC_bBitMask]
   mov   reg[X], A
   M8C_SetBank0

   pop   A                                       ; restore Port Number
   asl   A
   asl   A
   mov   X, A                                    ; Restore Port address in X

   ; Set mode to 01 (Digital Strong)
   M8C_SetBank1
   mov   A, reg[X+DM1_OFFSET]                    ; Set DM1 to 0
   and   A, [CSA_EMC_bBitMask]
   mov   reg[X+DM1_OFFSET], A
   xor   [CSA_EMC_bBitMask], FFh                 ; Invert bitmask back to normal
   mov   A, reg[X+DM0_OFFSET]                    ; Set DM0 bit to 1
   or    A, [CSA_EMC_bBitMask]
   mov   reg[X+DM0_OFFSET], A
   M8C_SetBank0

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;----------------------------INTERNAL FUNCTION-------------------------
;  FUNCTION NAME: CSA_EMC_ScanSingleSensor(BYTE bStrtIdx)
;
;  DESCRIPTION:
;  Uses the CapSense switching circuitry to charge to the starting voltage.
;  Then a fixed slope ramp is used to measure the starting voltage with a
;  16 bit timer.
;
;---------------------------------------------------------------------------------------
;
;  ARGUMENTS:
;      A  => Sensor Index
;
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
  ScanSingleSensor:
 CSA_EMC_ScanSingleSensor:
_CSA_EMC_ScanSingleSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   [CSA_EMC_bSensorNum], A
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_EnableSensor
   push  X
   
   ; This code discharges CMOD before sensor scan
IF(CSA_EMC_EXTERNAL_CAP & 01h)
   M8C_SetBank1
   or    reg[PRT0DM0], 02h  ; Set Strong Mode (Open Drain) of P0(1) for Data = 0
   M8C_SetBank0
   and   reg[PRT0DR], ~02h  ; Set Data = 0 of P0(1) 
IF(CSA_EMC_DISCHARGE_DELAY)   
   mov   A, CSA_EMC_DISCHARGE_DELAY              ; 4 usec delay
.DischargeLoop:
   dec   A
   jnc   .DischargeLoop
ENDIF 
   M8C_SetBank1
   and   reg[PRT0DM0], ~02h  ; Set high-Z analog of P0(1) back
   M8C_SetBank0   
ENDIF

IF(CSA_EMC_EXTERNAL_CAP & 02h)
   M8C_SetBank1
   or    reg[PRT0DM0], 08h  ; Set Strong Mode (Open Drain) of P0(3) for Data = 0
   M8C_SetBank0 
   and   reg[PRT0DR], ~08h  ; Set Data = 0 of P0(3)   
IF(CSA_EMC_DISCHARGE_DELAY)   
   mov   A, CSA_EMC_DISCHARGE_DELAY               ; 4 usec delay
.DischargeLoop:
   dec   A
   jnc   .DischargeLoop
ENDIF   
   M8C_SetBank1
   and   reg[PRT0DM0], ~08h  ; Set high-Z analog of P0(1) back
   M8C_SetBank0    
ENDIF  

   or    reg[CSA_EMC_CapSense_CR3_REG], 70h
   mov   A, 5
.DelayLoop:
   dec   A
   jnc   .DelayLoop

   mov   X, [CSA_EMC_bSensorNum]
   RAM_SETPAGE_IDX >CSA_EMC_baDACCodeBaseline
   mov   A, [X+CSA_EMC_baDACCodeBaseline]
.Retry:
   mov   reg[IDAC_D], A
   mov   reg[CSA_EMC_CapSense_CR2_REG], C4h                               ; Restore SA setup, 8x
   and   reg[CSA_EMC_CapSense_CR3_REG], ~70h
   or    reg[CSA_EMC_CapSense_CR0_REG], 01h                               ; Enable the CapSense block

   mov   X, [CSA_EMC_bSettlingTime]                                       ; Settling Time
   M8C_SetBank1
   mov   A, reg[e8h]
   push  A

.ChargeLoop:
IF (CSA_EMC_PRS)
   lcall SpreadSpectrum
ELSE
   nop
   nop
   nop
ENDIF
   dec   X
   jnc   .ChargeLoop
   pop   A
   mov   reg[e8h], A
   M8C_SetBank0

   ; Prepare to disconnect sensor from mux
   pop   X
   xor   [CSA_EMC_bBitMask], FFh                                          ; invert bit mask
   M8C_SetBank1
   mov   A, reg[X]
   M8C_SetBank0
   and   A, [CSA_EMC_bBitMask]

   or    reg[CMP_MUX], 2h
   mov   reg[CSA_EMC_CapSense_CR2_REG], 00h
   and   reg[CSA_EMC_CapSense_CR0_REG], ~01h                              ; Disable the CapSense block
   ; Disconnect sensor from mux
   M8C_SetBank1
   mov   reg[X], A
   M8C_SetBank0

   mov   reg[CSA_EMC_CapSense_CR1_REG], 80h                               ; Ramp should be clocked at IMO
   mov   X, [CSA_EMC_bSensorNum]
   mov   A, [CSA_EMC_bIDACSetting]
   mov   reg[IDAC_D], A
   mov   A, [CSA_EMC_bSensorNum]
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_DisableSensor
   or    [CSA_EMC_bfStatus], CSA_EMC_SCAN_ACTIVE                          ; Set scan active flag
   mov   reg[CSA_EMC_INT_CLR_REG], ~CSA_EMC_INT_MASK
   or    reg[CSA_EMC_CapSense_CR0_REG], 01h                               ; Enable the Counter
   mov   reg[CSA_EMC_CapSense_CR2_REG], CSA_EMC_IDAC_RANGE                ; Enable the IDAC
   CSA_EMC_EnableInt_M                                                    ; Enable the CapSense interrupt

.waitforinterrupt:
   tst   [CSA_EMC_bfStatus], CSA_EMC_SCAN_ACTIVE                          ; Set scan active flag
   jnz   .waitforinterrupt

   CSA_EMC_DisableInt_M

   and   reg[CMP_MUX], ~2h

   tst   reg[CSA_EMC_CapSense_STAT_REG], 20h                              ; Check for overflow
   jz    .NoOverflow

.Overflow:
   and   reg[CSA_EMC_CapSense_STAT_REG], ~20h                             ; Clear overflow
   and   reg[CSA_EMC_CapSense_CR0_REG], ~01h                              ; Disable the Counter
   mov   reg[CSA_EMC_CapSense_CR2_REG],  C4h                              ; Restore SA setup, 8x
   mov   reg[CSA_EMC_CapSense_CR1_REG], CSA_EMC_CLOCK                     ; SA should be clocked at IMO/X

   mov   A, [CSA_EMC_bSensorNum]
   call  CSA_EMC_wGetPortPin
   call  CSA_EMC_EnableSensor

   ; DAC Code Baseline is out of range
   call  CSA_EMC_bFindDACCodeBaseline
   mov   X, [CSA_EMC_bSensorNum]
   RAM_SETPAGE_IDX >CSA_EMC_baDACCodeBaseline
   mov   [X+CSA_EMC_baDACCodeBaseline], A
   or    [CSA_EMC_bfStatus], CSA_EMC_OVERFLOW
   mov   A, 0h   
   mov   [CSA_EMC_wADCResult+LSB], A
   mov   [CSA_EMC_wADCResult+MSB], A   
   jmp   .Done

.NoOverflow:
   ; Store the data
   mov   A, reg[CS_CNTL]
   mov   [CSA_EMC_wADCResult+LSB], A
   mov   A, reg[CS_CNTH]
   mov   [CSA_EMC_wADCResult+MSB], A

   and   reg[CSA_EMC_CapSense_CR0_REG], ~01h                              ; Disable the Counter
   mov   reg[CSA_EMC_CapSense_CR2_REG],  C4h                              ; Restore SA setup, 8x
   mov   reg[CSA_EMC_CapSense_CR1_REG], CSA_EMC_CLOCK                     ; SA should be clocked at IMO/X
.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_CopyIdacValue
;
;  DESCRIPTION: Updates bIdacValue value
;
;  INPUT:
;  A  => Sensor Index
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;
;-----------------------------------------------------------------------------
CopyIdacValue:
_CSA_EMC_CopyIdacValue:
 CSA_EMC_CopyIdacValue:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR  0
   RAM_SETPAGE_IDX >CSA_EMC_baDAC
   mov   X, A
   mov   A, [X+CSA_EMC_baDAC]
   mov   [CSA_EMC_bIdacValue], A  
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_ScanSensor(BYTE bStrtIdx)
;
;  DESCRIPTION:
;  Uses the CapSense switching circuitry to charge to the starting voltage.
;  Then a fixed slope ramp is used to measure the starting voltage with a
;  16 bit timer.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      A  => Sensor Index
;
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_ScanSensor:
_CSA_EMC_ScanSensor:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   
   mov   [CSA_EMC_bSensorNum], A                      ; Save sensor index
   call  CSA_EMC_CopyIdacValue
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index   
   lcall CSA_EMC_ScanSingleSensor
   
   tst   [CSA_EMC_bfStatus], CSA_EMC_OVERFLOW                             ; Reset Baseline?
   jz    .Cont
   mov   [CSA_EMC_bfStatus], 0
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   lcall CSA_EMC_InitializeSensorBaseline
.Cont:
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   asl   A
   lcall CSA_EMC_ProcessData

IF (CSA_EMC_IMMUNITY_LEVEL / 3)
  
   lcall PreProcessDataMedium

   tst   [CSA_EMC_bfStatus], CSA_EMC_OVERFLOW                             ; Reset Baseline?
   jz    .Cont1
   mov   [CSA_EMC_bfStatus], 0
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   lcall CSA_EMC_InitializeSensorBaseline
.Cont1:
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   add   A, CSA_EMC_TotalSensorCount
   asl   A
   lcall CSA_EMC_ProcessData

   lcall PreProcessDataHigh

   tst   [CSA_EMC_bfStatus], CSA_EMC_OVERFLOW                             ; Reset Baseline?
   jz    .Cont2
   mov   [CSA_EMC_bfStatus], 0
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   lcall CSA_EMC_InitializeSensorBaseline

.Cont2:
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   add   A, CSA_EMC_TotalSensorCount*2
   asl   A
   lcall CSA_EMC_ProcessData
   lcall PostProcessDataHigh
ELSE
   mov   [CSA_EMC_wX1+LSB], [CSA_EMC_wSig1+LSB]
   mov   [CSA_EMC_wX1+MSB], [CSA_EMC_wSig1+MSB]
ENDIF

   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   asl   A
   mov   X, A

   mov   A, [CSA_EMC_wX1+LSB]
   mov   [X+CSA_EMC_waSnsDiff+LSB], A
   mov   A, [CSA_EMC_wX1+MSB]
   mov   [X+CSA_EMC_waSnsDiff+MSB], A
 
   RAM_EPILOGUE RAM_USE_CLASS_3
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_ScanAllSensors(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_ScanAllSensors:
_CSA_EMC_ScanAllSensors:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

IF (CSA_EMC_PRS)
   mov   [CSA_EMC_bLFSR], CSA_EMC_SEED
ENDIF

   mov   A, CSA_EMC_TotalSensorCount-1
.ScanLoop:                                            ; Loop through all sensors and scan
   push  A
   call  CSA_EMC_ScanSensor
   pop   A
   dec   A
   jnc   .ScanLoop

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_wReadSensor(BYTE bSensor)
;
;  DESCRIPTION:
;     Returns the sensor scan value in A (LSB) and X (MSB)
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    A = Sensor number
;  RETURNS:
;    Scan value of sensor LSB in A and MSB in X
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to preserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_wReadSensor:
_CSA_EMC_wReadSensor:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   asl   A                                            ; Multiply by two since results are INTs
   mov   X,A
   mov   A,[X+(CSA_EMC_waSnsResult+LSB)]
   mov   X,[X+(CSA_EMC_waSnsResult+MSB)]
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION


