;;*****************************************************************************
;;  FILENAME: CSA_EMCHL.asm
;;   Version: 1.50, Updated on 2013/5/19 at 10:42:39
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: CSA_EMC User Module high level software
;;                implementation file
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "CSA_EMC.inc"

;-----------------------------------------------
; Global Symbols
;-----------------------------------------------

export _CSA_EMC_UpdateSensorBaseline
export  CSA_EMC_UpdateSensorBaseline
export _CSA_EMC_UpdateAllBaselines
export  CSA_EMC_UpdateAllBaselines
export _CSA_EMC_InitializeSensorBaseline
export  CSA_EMC_InitializeSensorBaseline
export _CSA_EMC_bIsSensorActive
export  CSA_EMC_bIsSensorActive
export _CSA_EMC_bIsAnySensorActive
export  CSA_EMC_bIsAnySensorActive
export _CSA_EMC_SetDefaultFingerThresholds
export  CSA_EMC_SetDefaultFingerThresholds
export _CSA_EMC_InitializeBaselines
export  CSA_EMC_InitializeBaselines
IF CSA_EMC_SLIDERS_EXIST
export _CSA_EMC_wGetCentroidPos
export  CSA_EMC_wGetCentroidPos
export _CSA_EMC_wGetRadialPos
export  CSA_EMC_wGetRadialPos
export _CSA_EMC_wGetRadialInc
export  CSA_EMC_wGetRadialInc
ENDIF
export MedianFilter:
export _CSA_EMC_MedianFilter
export  CSA_EMC_MedianFilter

IF (CSA_EMC_RAW_IIR_ENABLE)
export _CSA_EMC_IIRFilter
export  CSA_EMC_IIRFilter
ENDIF

export _CSA_EMC_ProcessData
export  CSA_EMC_ProcessData
export CopywADCResultToBaseline
export _CSA_EMC_CopywADCResultToBaseline
export  CSA_EMC_CopywADCResultToBaseline

;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM, REL, CON)

_CSA_EMC_bNoiseThreshold:
 CSA_EMC_bNoiseThreshold:                   BLK  1
_CSA_EMC_bNegativeNoiseThreshold:
 CSA_EMC_bNegativeNoiseThreshold:           BLK  1
_CSA_EMC_bBaselineUpdateThreshold:
 CSA_EMC_bBaselineUpdateThreshold:          BLK  1
_CSA_EMC_bHysteresis:
 CSA_EMC_bHysteresis:                       BLK  1
_CSA_EMC_bDebounce:
 CSA_EMC_bDebounce:                         BLK  1
_CSA_EMC_bLowBaselineReset:
 CSA_EMC_bLowBaselineReset:                 BLK  1

_wX1:
wX1:
_CSA_EMC_wX1:
 CSA_EMC_wX1:                               BLK  2
_wX2:
wX2:
_CSA_EMC_wX2:
 CSA_EMC_wX2:                               BLK  2
_wX3:
wX3:
_CSA_EMC_wX3:
 CSA_EMC_wX3:                               BLK  2
 
_waDiffCountHoppChannel1:
waDiffCountHoppChannel1:
_CSA_EMC_wSig1:
 CSA_EMC_wSig1:                             BLK  2
_waDiffCountHoppChannel2:
waDiffCountHoppChannel2:
_CSA_EMC_wSig2:
 CSA_EMC_wSig2:                             BLK  2
_waDiffCountHoppChannel3:
waDiffCountHoppChannel3:
_CSA_EMC_wSig3:
 CSA_EMC_wSig3:                             BLK  2

export _CSA_EMC_bNoiseThreshold
export  CSA_EMC_bNoiseThreshold
export _CSA_EMC_bNegativeNoiseThreshold
export  CSA_EMC_bNegativeNoiseThreshold
export _CSA_EMC_bBaselineUpdateThreshold
export  CSA_EMC_bBaselineUpdateThreshold
export _CSA_EMC_bHysteresis
export  CSA_EMC_bHysteresis
export _CSA_EMC_bDebounce
export  CSA_EMC_bDebounce
export _CSA_EMC_bLowBaselineReset
export  CSA_EMC_bLowBaselineReset
export  CSA_EMC_baLowBaselineReset

export _wX1
export wX1
export _CSA_EMC_wX1
export  CSA_EMC_wX1
export _wX2
export wX2
export _CSA_EMC_wX2
export  CSA_EMC_wX2
export _wX3
export wX3
export _CSA_EMC_wX3
export  CSA_EMC_wX3

export _waDiffCountHoppChannel1
export waDiffCountHoppChannel1
export _CSA_EMC_wSig1
export  CSA_EMC_wSig1
export _waDiffCountHoppChannel2
export waDiffCountHoppChannel2
export _CSA_EMC_wSig2
export  CSA_EMC_wSig2
export _waDiffCountHoppChannel3
export waDiffCountHoppChannel3
export _CSA_EMC_wSig3
export  CSA_EMC_wSig3

; Local variables
_CSA_EMC_bEndOfArray:                               ; Temp pointer variable
 CSA_EMC_bEndOfArray:                       BLK  1
_CSA_EMC_bCalMask:
 CSA_EMC_bCalMask:
_CSA_EMC_fIsPressed:                                ; Temp variable for if any sensor is pressed
 CSA_EMC_fIsPressed:                        BLK  1
_CSA_EMC_bCurPos:                                   ; Temp position variable
 CSA_EMC_bCurPos:                           BLK  1
_CSA_EMC_bSnsMaskPtr:                               ; Temp sensor mask pointer used in centroid calculation
 CSA_EMC_bSnsMaskPtr:                       BLK  1
_CSA_EMC_bStartIndex:                               ; Temp Start index
 CSA_EMC_bStartIndex:                       BLK  1
_CSA_EMC_wTmpBtnFThreshold:                         ; Temp Difference
 CSA_EMC_wTmpBtnFThreshold:                 BLK  2

IF CSA_EMC_SLIDERS_EXIST
; Local slider variables
_CSA_EMC_wDenom:                                    ; Denominator is also the Ctrd Pos
 CSA_EMC_wDenom:                            BLK  2
_CSA_EMC_dNumer:                                    ; Numerator also contains the Ctrd Pos
 CSA_EMC_dNumer:                            BLK  2
_CSA_EMC_wCtrdPos:                                  ; Ctrd Pos is LMSB and LLSB of the numerator
 CSA_EMC_wCtrdPos:                          BLK  2
_CSA_EMC_dMultTempX:                                ; Temp multiplication register
 CSA_EMC_dMultTempX:                        BLK  4
_CSA_EMC_dMultTempY:                                ; Temp multiplication register
 CSA_EMC_dMultTempY:                        BLK  4
_CSA_EMC_bCurSlider:
 CSA_EMC_bCurSlider:                        BLK  1
_CSA_EMC_bCurCtrdStartPos:                          ; Temp current centroid start position
 CSA_EMC_bCurCtrdStartPos:                  BLK  1
_CSA_EMC_bCurCtrdSize:                              ; Temp current centroid size
 CSA_EMC_bCurCtrdSize:                      BLK  1
_CSA_EMC_bBiggestCtrdStartPos:                      ; Temp biggest centroid start position
 CSA_EMC_bBiggestCtrdStartPos:              BLK  1
_CSA_EMC_bBiggestCtrdSize:                          ; Temp biggest centroid size
 CSA_EMC_bBiggestCtrdSize:                  BLK  1
_CSA_EMC_wCurPkValue:                               ; Temp current peak
 CSA_EMC_wCurPkValue:                       BLK  2
_CSA_EMC_bCurPkPos:                                 ; Temp current slider pointer
 CSA_EMC_bCurPkPos:                         BLK  1
_CSA_EMC_bDiplexInfo:                               ; Temp flag for diplex of current group
 CSA_EMC_bDiplexInfo:                       BLK  1
_CSA_EMC_bDiplexMSB:                                ; Temp that contains the address of the rom diplex table
 CSA_EMC_bDiplexMSB:                        BLK  1
_CSA_EMC_bDiplexLSB:
 CSA_EMC_bDiplexLSB:                        BLK  1
_CSA_EMC_wDivBtwSns:                                ; Temp divisions between sensors
 CSA_EMC_wDivBtwSns:                        BLK  2
_CSA_EMC_waCentroid:                                 ;array of Centroid and  two adjacent values (word array)
 CSA_EMC_waCentroid:                        BLK  6
ENDIF

AREA ram0 (RAM, REL, CON)

IF(CSA_EMC_RAW_MEDIAN_ENABLE)
 IF (CSA_EMC_RAW_IIR_ENABLE)
_CSA_EMC_waIIR::
 CSA_EMC_waIIR::
 ENDIF
_CSA_EMC_waSnsResult:                           ; Array of ints, FREQ_NUM entries for each sensor
 CSA_EMC_waSnsResult:                   BLK  (2*CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)
AREA ram3 (RAM, REL, CON)
_CSA_EMC_waRaw2::
 CSA_EMC_waRaw2::                       BLK  (2*CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)
ELSE
_CSA_EMC_waIIR::
 CSA_EMC_waIIR::
_CSA_EMC_waSnsResult:
 CSA_EMC_waSnsResult:                   BLK  (2*CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)
ENDIF


AREA ram1 (RAM, REL, CON)
; Global variables
_CSA_EMC_waSnsBaseline:                             ; Baseline, one entry for each sensor
 CSA_EMC_waSnsBaseline:                     BLK  (2*CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL)

AREA ram2 (RAM, REL, CON)
_CSA_EMC_baSnsBucket:                                 ; Baseline difference accumulator, one entry for each sensor
 CSA_EMC_baSnsBucket:                       BLK  CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL
_CSA_EMC_baBtnFThreshold:                           ; Containing variable finger threshold for each button
 CSA_EMC_baBtnFThreshold:                   BLK  CSA_EMC_TotalSensorCount
_CSA_EMC_baSnsOnMask:                               ; Sensor mask array containing on/off state of sensors
IF (CSA_EMC_TotalSensorCount)
 CSA_EMC_baSnsOnMask:                       BLK  ((CSA_EMC_TotalSensorCount-1)/8)+1
ELSE
 CSA_EMC_baSnsOnMask:                       BLK  1
ENDIF
_CSA_EMC_baSnsDebounce:
 CSA_EMC_baSnsDebounce:                     BLK  CSA_EMC_TotalSensorCount


AREA ram4 (RAM, REL, CON) 
_CSA_EMC_waSnsDiff:                                 ; ABS Diff of raw and and baseline, one entry for each sensor
 CSA_EMC_waSnsDiff:                         BLK  (2*CSA_EMC_TotalSensorCount) 
_CSA_EMC_baLowBaselineReset:
 CSA_EMC_baLowBaselineReset:                BLK  CSA_EMC_TotalSensorCount*CSA_EMC_IMMUNITY_LEVEL

AREA bss
IF CSA_EMC_SLIDERS_EXIST
_CSA_EMC_waCtrdPkValue:                             ; Array containing peak value of centroid
 CSA_EMC_waCtrdPkValue:                     BLK  (2*CSA_EMC_SliderCount)
_CSA_EMC_waSliderPrevPos:                     ;
 CSA_EMC_waSliderPrevPos:                   BLK  (2*CSA_EMC_SliderCount)
_CSA_EMC_waSliderCurrPos:                     ;
 CSA_EMC_waSliderCurrPos:                   BLK  (2*CSA_EMC_SliderCount)
ENDIF

; Global variables
export  CSA_EMC_waSnsResult
export _CSA_EMC_waSnsResult
export _CSA_EMC_waSnsBaseline
export  CSA_EMC_waSnsBaseline
export _CSA_EMC_waSnsDiff
export  CSA_EMC_waSnsDiff
export _CSA_EMC_baBtnFThreshold
export  CSA_EMC_baBtnFThreshold
export _CSA_EMC_baSnsOnMask
export  CSA_EMC_baSnsOnMask
export _CSA_EMC_baSnsDebounce
export  CSA_EMC_baSnsDebounce

; Local variables
export _CSA_EMC_fIsPressed
export  CSA_EMC_fIsPressed
export _CSA_EMC_bCalMask
export  CSA_EMC_bCalMask
export _CSA_EMC_bEndOfArray
export  CSA_EMC_bEndOfArray
export _CSA_EMC_bCurPos
export  CSA_EMC_bCurPos
export _CSA_EMC_bSnsMaskPtr
export  CSA_EMC_bSnsMaskPtr

IF CSA_EMC_SLIDERS_EXIST
; Local slider variables
export _CSA_EMC_wDenom
export  CSA_EMC_wDenom
export _CSA_EMC_wCtrdPos
export  CSA_EMC_wCtrdPos
export _CSA_EMC_dNumer
export  CSA_EMC_dNumer
export _CSA_EMC_dMultTempX
export  CSA_EMC_dMultTempX
export _CSA_EMC_dMultTempY
export  CSA_EMC_dMultTempY
export _CSA_EMC_bCurCtrdStartPos
export  CSA_EMC_bCurCtrdStartPos
export _CSA_EMC_bCurCtrdSize
export  CSA_EMC_bCurCtrdSize
export _CSA_EMC_bBiggestCtrdStartPos
export  CSA_EMC_bBiggestCtrdStartPos
export _CSA_EMC_bBiggestCtrdSize
export  CSA_EMC_bBiggestCtrdSize
export _CSA_EMC_wCurPkValue
export  CSA_EMC_wCurPkValue
export _CSA_EMC_bCurPkPos
export  CSA_EMC_bCurPkPos
export _CSA_EMC_bDiplexMSB
export  CSA_EMC_bDiplexMSB
export _CSA_EMC_bDiplexLSB
export  CSA_EMC_bDiplexLSB
export _CSA_EMC_wDivBtwSns
export  CSA_EMC_wDivBtwSns
export _CSA_EMC_waSliderPrevPos
export  CSA_EMC_waSliderPrevPos
export _CSA_EMC_waSliderCurrPos
export  CSA_EMC_waSliderCurrPos
ENDIF

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; User Includes
;------------------------


;------------------------
; User Constant Definitions
;------------------------


;------------------------
; User Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)

IF	(TOOLCHAIN & HITECH)
  AREA lit (ROM,REL,CON)
ELSE
  AREA lit (ROM,REL,CON,LIT)
ENDIF

;-----------------------------------------------------------------------------
; Diplex table scan order data is produced for a group when it is a slider and
; is also diplexed.  Otherwise a label is created but no data is placed.  The
; data represents the physical representation of the sensors in their location
; on the PCB.  A label containing the pointer to the corresponding table is
; also produced for referencing in the high-level centroid calculation
; function.
;-----------------------------------------------------------------------------

IF(CSA_EMC_DiplexUsed)
.LITERAL
ENDIF

DiplexTable_0:
; This group is not a diplexed slider

IF(CSA_EMC_DiplexUsed)
.ENDLITERAL
ENDIF

;------------------------
;  Constant Definitions
;------------------------
AREA UserModules (ROM, REL, CON)

; For using two byte variables
LSB:  equ  1
MSB:  equ  0

; For using four byte variables
MMSB: equ 0
MLSB: equ 1
LMSB: equ 2
LLSB: equ 3

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_UpdateAllBaselines(void)
;
;  DESCRIPTION:
;    Doing nothing. Added for compatibility
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
_CSA_EMC_UpdateAllBaselines:
 CSA_EMC_UpdateAllBaselines:
  ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_UpdateSensorBaseline(BYTE bSensorIdx)
;
;  DESCRIPTION:
;    Doing nothing. Added for compatibility
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
_CSA_EMC_UpdateSensorBaseline:
 CSA_EMC_UpdateSensorBaseline:
  ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_UpdateBaseline(BYTE bSensorIdx)
;
;  DESCRIPTION:
;      Update baseline for one sensor. The algorithm is as follows:
;        If difference count is negative baseline become raw count
;        If difference count is above noise threshold do not update
;        Else difference count is positive and within noise threshold so
;        difference is halved and added to the bucket. When the bucket
;        reaches the threshold the baseline increments and the bucket resets
;-----------------------------------------------------------------------------
;  STACK USAGE: 0 BYTES
;
;  ARGUMENTS:
;      A => Sensor index
;
;  RETURNS:
;      Nothing
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_UpdateBaseline:
_CSA_EMC_UpdateBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   X, A

   ; Get the difference counts
   mov   A, [CSA_EMC_wADCResult+LSB]
   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
   sub   A, [X+CSA_EMC_waSnsBaseline+LSB]
   mov   [CSA_EMC_wSig1+LSB], A
   mov   A, [CSA_EMC_wADCResult+MSB]
   sbb   A, [X+CSA_EMC_waSnsBaseline+MSB]
   mov   [CSA_EMC_wSig1+MSB], A
                                                                               ; Is difference negative?
   jc    .IsNegative

IF (CSA_EMC_AUTORESET)
   cmp   [CSA_EMC_wSig1+MSB], 0
   jz    .AddBucketLSB
   mov   A, 127
   jmp   .AddBucketConst
ELSE
   ; Compare to Noise Threshold
   cmp   [CSA_EMC_wSig1+MSB], 0
   jnz   .InitLowBaselineReset
   mov   A, [CSA_EMC_bNoiseThreshold]
   cmp   A, [CSA_EMC_wSig1+LSB]
   jc    .InitLowBaselineReset
ENDIF

   ; Add to the Bucket
.AddBucketLSB:
   mov   A, [CSA_EMC_wSig1+LSB]
   add   A, 0
   rrc   A                                                                     ; For slower tracking
.AddBucketConst:
   swap  A, X
   asr   A
   swap  A, X
   RAM_SETPAGE_IDX >CSA_EMC_baSnsBucket
   add   [X+CSA_EMC_baSnsBucket], A
   jc    .DoInc
   mov   A, [CSA_EMC_bBaselineUpdateThreshold]
   cmp   A, [X+CSA_EMC_baSnsBucket]
   jnc   .EndBucket
   jz    .EndBucket
.DoInc:
   ; Increment Baseline
   mov   [X+CSA_EMC_baSnsBucket], 0
   mov   A, X
   asl   A
   mov   X, A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
   add   [X+CSA_EMC_waSnsBaseline+LSB], 1
   adc   [X+CSA_EMC_waSnsBaseline+MSB], 0

   mov A, X
   asr A
   mov X, A
.EndBucket:
   swap A, X
   asl A
   swap X, A
IF (CSA_EMC_AUTORESET)
   ; Compare to Noise Threshold
   cmp   [CSA_EMC_wSig1+MSB], 0
   jnz   .InitLowBaselineReset
   mov   A, [CSA_EMC_bNoiseThreshold]
   cmp   A, [CSA_EMC_wSig1+LSB]
   jc    .InitLowBaselineReset
ELSE
ENDIF
   jmp   .SetDifferenceToZero

.IsNegative:
   ; Compare to Negative Noise Threshold
   cmp   [CSA_EMC_wSig1+MSB], FFh
   jnz   .CheckLowBaseline
   mov   A, FFh
   sub   A, [CSA_EMC_bNegativeNoiseThreshold]
   cmp   A, [CSA_EMC_wSig1+LSB]
   jc    .LowerBaseline
.CheckLowBaseline:
   ; Set difference to zero
   mov   [CSA_EMC_wSig1+LSB], 0
   mov   [CSA_EMC_wSig1+MSB], 0
   ; Check Low Baseline Reset
   mov   A, X
   asr   A
   mov   X, A
   RAM_SETPAGE_IDX >CSA_EMC_baLowBaselineReset
   mov   A, [X+CSA_EMC_baLowBaselineReset]
   dec   A
   jnc   .Gt0
   mov   A, 0
.Gt0:
   mov   [X+CSA_EMC_baLowBaselineReset], A
   push  A
   mov   A, X
   asl   A
   mov   X, A
   pop   A
   jnz  .EndofUpdateSensorBaseline

.LowerBaseline:
   mov A, [CSA_EMC_wADCResult+LSB]
   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
   mov [X+CSA_EMC_waSnsBaseline+LSB], A
   mov A, [CSA_EMC_wADCResult+MSB]
   mov [X+CSA_EMC_waSnsBaseline+MSB], A

.SetDifferenceToZero:
   ; Set difference to zero
   mov   [CSA_EMC_wSig1+LSB], 0
   mov   [CSA_EMC_wSig1+MSB], 0
.InitLowBaselineReset:
   mov   A, X
   asr   A
   mov   X, A
   RAM_SETPAGE_IDX >CSA_EMC_baLowBaselineReset
   mov   A, [CSA_EMC_bLowBaselineReset]
   mov   [X+CSA_EMC_baLowBaselineReset], A

.EndofUpdateSensorBaseline:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_bIsSensorActive(BYTE bSensorNum)
;
;  DESCRIPTION:
;      Returns state of one sensor.    Updates the baSnsOnMask array.
;      Implements hysteresis based on the Hysteresis parameter.
;-----------------------------------------------------------------------------
;  STACK USAGE: 3 BYTES
;
;  ARGUMENTS:
;      A => sensor index
;
;  RETURNS:
;      A => 1 if sensor is active, 0 otherwise
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_bIsSensorActive:
_CSA_EMC_bIsSensorActive:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   push A
   mov X,A
   RAM_SETPAGE_IDX >CSA_EMC_baBtnFThreshold
   mov A, [X+CSA_EMC_baBtnFThreshold]
   mov [CSA_EMC_wTmpBtnFThreshold+LSB], A
   mov [CSA_EMC_wTmpBtnFThreshold+MSB], 0

   pop A
   push A
   call CSA_EMC_GetOnMask
   RAM_SETPAGE_IDX >CSA_EMC_baSnsOnMask
   and A, [X+CSA_EMC_baSnsOnMask]
   jnz .WasOn

.WasOff:
   ; Check the difference counts against the threshold
   mov A, [CSA_EMC_bHysteresis]
   add [CSA_EMC_wTmpBtnFThreshold+LSB], A
   adc [CSA_EMC_wTmpBtnFThreshold+MSB], 0
   pop A
   asl A
   mov X, A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov A, [X+CSA_EMC_waSnsDiff+LSB]
   sub A, [CSA_EMC_wTmpBtnFThreshold+LSB]
   mov A, [X+CSA_EMC_waSnsDiff+MSB]
   sbb A, [CSA_EMC_wTmpBtnFThreshold+MSB]
   jc .NotActive
   mov A, X
   asr A
   mov X, A
   RAM_SETPAGE_IDX >CSA_EMC_baSnsDebounce
   mov A, [X+CSA_EMC_baSnsDebounce]
   dec A
   mov [X+CSA_EMC_baSnsDebounce], A
   push A
   mov A, X
   asl A
   mov X, A
   pop A
   jnz .NotActiveDebouncing
   jmp .Active

.WasOn:
   ; Check the difference counts against the threshold
   mov A, [CSA_EMC_bHysteresis]
   sub [CSA_EMC_wTmpBtnFThreshold+LSB], A
   sbb [CSA_EMC_wTmpBtnFThreshold+MSB], 0
   pop A
   asl A
   mov X, A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov A, [X+CSA_EMC_waSnsDiff+LSB]
   sub A, [CSA_EMC_wTmpBtnFThreshold+LSB]
   mov A, [X+CSA_EMC_waSnsDiff+MSB]
   sbb A, [CSA_EMC_wTmpBtnFThreshold+MSB]
   jc .NotActive

.Active:
   mov A, X
   asr A
   call CSA_EMC_GetOnMask
   RAM_SETPAGE_IDX >CSA_EMC_baSnsOnMask
   or [X+CSA_EMC_baSnsOnMask], A
   mov A, 1
   jmp .EndIsSensorActive
.NotActive:
   mov A, X
   asr A
   push A
   call CSA_EMC_GetOnMask
   cpl A
   RAM_SETPAGE_IDX >CSA_EMC_baSnsOnMask
   and [X+CSA_EMC_baSnsOnMask], A
   RAM_SETPAGE_IDX >CSA_EMC_baSnsDebounce
   pop X
   mov A, [CSA_EMC_bDebounce]
   mov [X+CSA_EMC_baSnsDebounce], A
   mov A, 0
   jmp .EndIsSensorActive
.NotActiveDebouncing:
   mov A, X
   asr A
   call CSA_EMC_GetOnMask
   cpl A
   RAM_SETPAGE_IDX >CSA_EMC_baSnsOnMask
   and [X+CSA_EMC_baSnsOnMask], A
   mov A, 0
.EndIsSensorActive:
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

.ENDSECTION

 CSA_EMC_GetOnMask:
_CSA_EMC_GetOnMask:
   push A
   asr A
   asr A
   asr A
   mov X, A
   pop A
   and A, 7h
   index CSA_EMC_bitlookup
   ret

.LITERAL
CSA_EMC_bitlookup:
    db 01h, 02h, 04h, 08h, 10h, 20h, 40h, 80h
.ENDLITERAL


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_SetDefaultFingerThresholds(void)
;
;  DESCRIPTION:
;    Sets the FingerThreshold RAM array to the user module parameter value
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_SetDefaultFingerThresholds:
_CSA_EMC_SetDefaultFingerThresholds:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_IDX >CSA_EMC_baBtnFThreshold

   mov   X, (CSA_EMC_TotalSensorCount - 1)            ; Check if key value in range.
.ThresholdLoop:                                              ; Loop through all sensors and scan
   mov   [X+CSA_EMC_baBtnFThreshold], CSA_EMC_FINGER_THRESHOLD
   dec   X
   jnc   .ThresholdLoop
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_InitializeBaselines(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their initial raw count values and loads these
;    into the baseline
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_InitializeBaselines:
_CSA_EMC_InitializeBaselines:
   RAM_PROLOGUE RAM_USE_CLASS_1

   mov   A, (CSA_EMC_TotalSensorCount - 1)
.BaselineLoop:                                        ; Loop through all sensors
   push  A
   call  CSA_EMC_InitializeSensorBaseline
   pop   A
   dec   A
   jnc   .BaselineLoop
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_InitializeSensorBaseline(BYTE bSensorNum)
;
;  DESCRIPTION:
;    Scans all sensors to find their initial raw count values and loads these
;    into the baseline
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_InitializeSensorBaseline:
_CSA_EMC_InitializeSensorBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_1

   mov   [CSA_EMC_bSensorNum], A                      ; Save sensor index
   lcall  CSA_EMC_CopyIdacValue
   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index 
   lcall  CSA_EMC_ScanSingleSensor

   mov   A, [CSA_EMC_bSensorNum]                      ; Get sensor index
   call  CSA_EMC_CopywADCResultToBaseline 
   
IF (CSA_EMC_IMMUNITY_LEVEL / 3)
   lcall InitSBaselineMedium
   lcall InitSBaselineHigh 
   lcall RestoreNormalScan
ENDIF

   RAM_EPILOGUE RAM_USE_CLASS_1
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_CopywADCResultToBaseline
;
;  DESCRIPTION: Updates Baseline value
;
;  INPUT:
;  A  => Sensor Index
;
;  RETURNS:      None.
;  SIDE EFFECTS:
;
;-----------------------------------------------------------------------------
CopywADCResultToBaseline:
_CSA_EMC_CopywADCResultToBaseline:
 CSA_EMC_CopywADCResultToBaseline:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR  0
   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult

   asl   A                                                 ; Set Int Offset  
   mov   X, A
   mov   A, [CSA_EMC_wADCResult + LSB]
   
   mov   [X + CSA_EMC_waSnsResult+LSB], A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
   mov   [X + CSA_EMC_waSnsBaseline + LSB], A
   
IF (CSA_EMC_RAW_IIR_ENABLE)
   RAM_SETPAGE_IDX >CSA_EMC_waIIR
   mov   [X+CSA_EMC_waIIR+LSB], A
ENDIF   
IF (CSA_EMC_RAW_MEDIAN_ENABLE)
   RAM_SETPAGE_IDX >CSA_EMC_waRaw2
   mov   [X +CSA_EMC_waRaw2+LSB], A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
ENDIF

   RAM_SETPAGE_IDX >CSA_EMC_waSnsBaseline
   mov   A, [CSA_EMC_wADCResult + MSB]
   mov   [X +CSA_EMC_waSnsBaseline + MSB], A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   [X +CSA_EMC_waSnsResult + MSB], A

IF (CSA_EMC_RAW_IIR_ENABLE)
   RAM_SETPAGE_IDX >CSA_EMC_waIIR
   mov   [X +CSA_EMC_waIIR+MSB], A
ENDIF   
IF (CSA_EMC_RAW_MEDIAN_ENABLE)
   RAM_SETPAGE_IDX >CSA_EMC_waRaw2
   mov   [X +CSA_EMC_waRaw2+MSB], A
ENDIF
   
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_bIsAnySensorActive(void)
;
;  DESCRIPTION:
;    Checks to see if any sensor is currently active
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      1 if any active, 0 if none active
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_bIsAnySensorActive:
_CSA_EMC_bIsAnySensorActive:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov [CSA_EMC_fIsPressed], 0
   mov   A, (CSA_EMC_TotalSensorCount - 1)
.ThresholdLoop:                                       ; Loop through all sensors
   push  A
   call  CSA_EMC_bIsSensorActive
   cmp   A, 1
   jnz    .NotActive
   mov [CSA_EMC_fIsPressed], 1
.NotActive:
   pop   A
   dec   A
   jnc   .ThresholdLoop
   mov   A, [CSA_EMC_fIsPressed]

.NoneActive:
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.LITERAL
;-----------------------------------------------------------------------------
; Diplex table scan order data is produced for a group when it is a slider and
; is also diplexed.  Otherwise a label is created but no data is placed.  The
; data represents the physical representation of the sensors in their location
; on the PCB.  A label containing the pointer to the corresponding table is
; also produced for referencing in the high-level centroid calculation
; function.
;-----------------------------------------------------------------------------
 CSA_EMC_Diplex_Table:
_CSA_EMC_Diplex_Table:
	db >DiplexTable_0, <DiplexTable_0

.ENDLITERAL

.LITERAL
;-----------------------------------------------------------------------------
; The Group Table defines each of the groups of button sensors or sliders.
; There is one entry for each slider plus one for the free button sensors.
; The first entry is always the free sensors.  Each entry is four bytes.
;
; The first byte is the index in the Sensor Table where the group starts.
;
; The second byte is how many sensors are in that group.  For example, in a
; system where there are 8 free sensors and two sliders, the first with 8
; sensors and the second with 4, the table would look like the following.
;  db 0, 8
;  db 8, 8
;  db 16, 4
;
; The third byte signifies whether the slider is diplexed or not (4 is
; diplexed, 0 is not diplexed).
;
; The fourth, fifth, and sixth bytes are the fixed point multiplier that the
; slider's calculated centroid will be multiplied by to achieve the resolution
; desired in the CSA_EMCwizard.  The multiplier is three bytes containing the
; following bit definitions:
;  MSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x2^15	  x2^14   x2^13   x2^12   x2^11   x2^10   x2^9    x2^8
;  ISB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x128	  x64     x32     x16     x8      x4      x2      x1
;  LSB:
;    bit 7   bit 6   bit 5   bit 4   bit 3   bit 2   bit 1   bit 0
;     x1/2	  x1/4    x1/8    x1/16   x1/32   x1/64   x1/128  x1/256
;
; The formula for the Multiplier is:
; Multiplier = ((Resolution-1) * 256) / (SensorsInSlider - 1)
;
; For example, if you had a 10 sensor slider and you wanted a resolution of
; 100, the multiplier would need to be 0x000B00:
; MSB 00h
; ISB 0Bh
; LSB 00h
; The GUI automatically calculates these values based on the resolution needed.
;
; There are 0x0 groups counting the free sensors.
;-----------------------------------------------------------------------------
 CSA_EMC_Group_Table:
_CSA_EMC_Group_Table:
; Group Table:
;    Origin    Count    Diplex?    DivBtwSw(wholeMSB, wholeLSB, fractByte)
 db   0x0,      0x09,	 0x00,	 0x00,	 0x00,	 0x00 ; Buttons

.ENDLITERAL

IF CSA_EMC_SLIDERS_EXIST
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_wGetCentroidPos(BYTE bSnsGroup)
;
;  DESCRIPTION:
;      Checks the difference array for a centroid.  If one exists, the offset
;      (within the whole difference arrary) and length are placed in the
;      bCentroidLength and bCentroidStart variables.
;
;      Then the function finds and returns the position of the centroid in the
;      difference array.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;       A => Sensor Group
;       Sensor Group = 0 for the independent sensors group
;       Sensor Group = 1 for the first slider group
;       Sensor Group = 2 for the second slider group
;
;  RETURNS:
;      iCtrdPos -> position of the centroid
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_wGetCentroidPos:
_CSA_EMC_wGetCentroidPos:
; Legacy function name labels below, do not use for new designs
 CSA_EMC_bGetCentroidPos:
_CSA_EMC_bGetCentroidPos:
 CSA_EMC_iGetCentroidPos:
_CSA_EMC_iGetCentroidPos:
; End legacy function names
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

; First get the starting location and size of this sensor group
   asl A ; multiply by two to get diplex
   mov X, A
   index CSA_EMC_Diplex_Table ; get the diplex table MSB and LSB
   mov [CSA_EMC_bDiplexMSB], A
   mov A, X
   inc A
   index CSA_EMC_Diplex_Table
   mov [CSA_EMC_bDiplexLSB], A
   mov A, X
   mov [CSA_EMC_bStartIndex], A ; Use bStartIndex as a temp storage byte
   asl A
   add [CSA_EMC_bStartIndex], A
   mov A, [CSA_EMC_bStartIndex] ; A now has slider offset multiplied by six
   mov X, A
   index CSA_EMC_Group_Table ; get first sensor index
   mov [CSA_EMC_bEndOfArray], A
   mov [CSA_EMC_bCurPos], A
   mov [CSA_EMC_bStartIndex], A
   mov A, X
   inc A
   index CSA_EMC_Group_Table ; get size of group
   add [CSA_EMC_bEndOfArray], A ; Store for later
   mov A, X
   add A, 2
   index CSA_EMC_Group_Table ; get if diplexed or not and max size of centroid (data = 0 if not diplexed)
   mov [CSA_EMC_bDiplexInfo], A ; Store for later
   mov A, X
   add A, 3
   mov [CSA_EMC_bSnsMaskPtr], A ; Store starting position in an unused temp CSA_EMC_bSnsMaskPtr

; First find the starting location and size of the largest centroid
   mov [CSA_EMC_bBiggestCtrdStartPos], 0
   mov [CSA_EMC_bBiggestCtrdSize], 0
   mov [CSA_EMC_bCurCtrdStartPos], 0
   mov [CSA_EMC_bCurCtrdSize], 0

   mov A, [CSA_EMC_bStartIndex]
   asl A ; multiply by two because we are using ints
   mov X, A

.LocateCtrd:
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov A, [X+CSA_EMC_waSnsDiff]
   jnz .DiffIsNotZero
   mov A, [X+CSA_EMC_waSnsDiff+1]
   jnz .DiffIsNotZero
; The difference is zero, we either just ended a centroid or are between centroids
; First check the Current Size, if zero, we are in the middle of zeros, else, we just ended
.DifferenceIsZero:
   mov A, [CSA_EMC_bCurCtrdSize]
   jz .LocateCtrdNextSensor
; A centroid just ended.  Is it the largest centroid?
   cmp A, [CSA_EMC_bBiggestCtrdSize]
   jc .ClearCurCtrdSize
; It is the biggest so far, store as biggest
   mov [CSA_EMC_bBiggestCtrdSize], [CSA_EMC_bCurCtrdSize]
   mov [CSA_EMC_bBiggestCtrdStartPos], [CSA_EMC_bCurCtrdStartPos]
.ClearCurCtrdSize:
   mov [CSA_EMC_bCurCtrdSize], 0
   jmp .LocateCtrdNextSensor

;The difference is not zero, we either just started, or are in the middle of a centroid
.DiffIsNotZero:
   mov A, [CSA_EMC_bCurCtrdSize]
   jnz .IncCtrdSize
; Centroid just began, store the start pos
   mov A, [CSA_EMC_bCurPos]
   mov [CSA_EMC_bCurCtrdStartPos], A
.IncCtrdSize:
   inc [CSA_EMC_bCurCtrdSize]
; Find out the next position
.LocateCtrdNextSensor:
   inc X
   inc X
   inc [CSA_EMC_bCurPos]
   mov A, [CSA_EMC_bCurPos]
   cmp A, [CSA_EMC_bEndOfArray] ; Check for the end of the array
   jc .LocateCtrd
; Either at end of array, or diplexed
   tst [CSA_EMC_bDiplexInfo], 0xff ; check if diplexed
   jz .EndOfLocateCtrd
; Diplexed, so now find out if at end
   sub A, [CSA_EMC_bEndOfArray] ; subtract the size of the array
   add A, [CSA_EMC_bStartIndex] ; for comparison
   cmp A, [CSA_EMC_bEndOfArray] ; Check for the end of the array
   jnc .EndOfLocateCtrd
; Not the end of the diplexed array, find out offset of next position
   mov A, [CSA_EMC_bCurPos]
   sub A, [CSA_EMC_bStartIndex]
   add A, [CSA_EMC_bDiplexLSB]
   mov X, A
   mov A, [CSA_EMC_bDiplexMSB]
   adc A, 0 ; check if carry
   romx ; get the offset from the start
   add A, [CSA_EMC_bStartIndex]
   asl A ; because using ints
   mov X, A
   jmp .LocateCtrd
.EndOfLocateCtrd:
; Need to check if the current centroid is biggest
   mov A, [CSA_EMC_bCurCtrdSize]
   jz .CalculateCtrd
; There was a centroid at the end, is it biggest?
   cmp A, [CSA_EMC_bBiggestCtrdSize]
   jc .CalculateCtrd ; if two are the same size, last one wins
; It is the biggest so far, store as biggest
   mov [CSA_EMC_bBiggestCtrdSize], [CSA_EMC_bCurCtrdSize]
   mov [CSA_EMC_bBiggestCtrdStartPos], [CSA_EMC_bCurCtrdStartPos]

.CalculateCtrd:
   mov A, [CSA_EMC_bBiggestCtrdSize]
   jz .COM_Error
   mov A, [CSA_EMC_bDiplexInfo] ; check if diplexed
   jz .COM_Init
   cmp [CSA_EMC_bBiggestCtrdSize], 2
   jc .COM_Error ; for diplexing, one or less is too small
   cmp A, [CSA_EMC_bBiggestCtrdSize]
   jc .COM_Error ; for diplexing, check if centroid is too large

.COM_Init:
   mov A, [CSA_EMC_bBiggestCtrdStartPos] ; Use for current position, may be diplexed
   mov [CSA_EMC_bCurPos], A
   mov [CSA_EMC_wDenom+MSB], 0 ; Clear the numerator and denominator
   mov [CSA_EMC_wDenom+LSB], 0
   mov [CSA_EMC_dNumer+MMSB], 0
   mov [CSA_EMC_dNumer+MLSB], 0
   mov [CSA_EMC_dNumer+LMSB], 0
   mov [CSA_EMC_dNumer+LLSB], 0

.COM_NextPosition:
   mov A, [CSA_EMC_bCurPos]
   cmp A, [CSA_EMC_bEndOfArray]
   jnc .COM_CheckDiplex
   asl A
   mov X, A
   jmp .COM_AddElement
; Must be diplexed, check for safe measure
.COM_CheckDiplex:
   tst [CSA_EMC_bDiplexInfo], 0xff ; check if diplexed
   jz .COM_Compute
; Find out offset of next position
   mov A, [CSA_EMC_bCurPos]
   sub A, [CSA_EMC_bStartIndex]
   add A, [CSA_EMC_bDiplexLSB]
   mov X, A
   mov A, [CSA_EMC_bDiplexMSB]
   adc A, 0 ; check if carry
   romx ; get the offset from the start
   add A, [CSA_EMC_bStartIndex]
   asl A ; because using ints
   mov X, A
.COM_AddElement:
; Subtract the noise from the difference, this will yield a more accurate result
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov A, [CSA_EMC_bNoiseThreshold]
   sub [X+CSA_EMC_waSnsDiff+LSB], A
   sbb [X+CSA_EMC_waSnsDiff+MSB], 0
; Store a copy of the sensor difference in CSA_EMC_dMultTempX
   mov A, [X+CSA_EMC_waSnsDiff+LSB]
   mov [CSA_EMC_dMultTempX+LLSB], A
; Add LSB to denominator
   add [CSA_EMC_wDenom+LSB], A
   mov A, [X+CSA_EMC_waSnsDiff]
   mov [CSA_EMC_dMultTempX+LMSB], A
   mov [CSA_EMC_dMultTempX+MLSB], 0
   mov [CSA_EMC_dMultTempX+MMSB], 0
; Add MSB to denominator
   adc [CSA_EMC_wDenom], A
   mov A, [CSA_EMC_bCurPos]
   sub A, [CSA_EMC_bStartIndex] ; we need offset from beginning of group
   mov [CSA_EMC_wDivBtwSns+MSB], 0
   mov [CSA_EMC_wDivBtwSns+LSB], A

   call .MultiplyNumeratorWhole

   inc [CSA_EMC_bCurPos]
   dec [CSA_EMC_bBiggestCtrdSize]
   jz .COM_Compute
   jmp .COM_NextPosition

.COM_Compute:
   mov A, [CSA_EMC_dNumer+LLSB] ; Move numerator to temp
   mov [CSA_EMC_dMultTempX+LLSB], A
   mov [CSA_EMC_dMultTempY+LLSB], A
   mov A, [CSA_EMC_dNumer+LMSB]
   mov [CSA_EMC_dMultTempX+LMSB], A
   mov [CSA_EMC_dMultTempY+LMSB], A
   mov A, [CSA_EMC_dNumer+MLSB]
   mov [CSA_EMC_dMultTempX+MLSB], A
   mov [CSA_EMC_dMultTempY+MLSB], A
   mov A, [CSA_EMC_dNumer+MMSB]
   mov [CSA_EMC_dMultTempX+MMSB], A
   mov [CSA_EMC_dMultTempY+MMSB], A

   mov [CSA_EMC_dNumer+MMSB], 0 ; Clear numerator
   mov [CSA_EMC_dNumer+MLSB], 0
   mov [CSA_EMC_dNumer+LMSB], 0
   mov [CSA_EMC_dNumer+LLSB], 0

   mov A, [CSA_EMC_bSnsMaskPtr] ; Retrieve starting position in index of the DivBtwSns
   push A
   index CSA_EMC_Group_Table ; get MSB of whole multiplier
   mov [CSA_EMC_wDivBtwSns+MSB], A
   pop A
   inc A
   push A
   index CSA_EMC_Group_Table ; get LSB of whole multiplier
   mov [CSA_EMC_wDivBtwSns+LSB], A
   call .MultiplyNumeratorWhole ; Multiplies by whole part
   pop A
   inc A
   index CSA_EMC_Group_Table ; get byte of fractional multiplier
   mov [CSA_EMC_wDivBtwSns+LSB], A
   call .MultiplyNumeratorFraction ; Multiplies by fractional part

; Now do the division of the numerator and denominator

; Round up the temp by half of the denominator (0.5 gets 1)
   mov A, [CSA_EMC_wDenom+MSB]
   mov [CSA_EMC_dMultTempX+MSB], A
   mov A, [CSA_EMC_wDenom+LSB]
   mov [CSA_EMC_dMultTempX+LSB], A
   and F, ~0x04 ; Clear carry bit if set
   rrc [CSA_EMC_dMultTempX+MSB] ; divide denominator by 2
   rrc [CSA_EMC_dMultTempX+LSB]
   mov A, [CSA_EMC_dMultTempX+LSB]
   add [CSA_EMC_dNumer+LLSB], A ; add 1/2 denominator
   mov A, [CSA_EMC_dMultTempX+MSB]
   adc [CSA_EMC_dNumer+LMSB], A
   adc [CSA_EMC_dNumer+MLSB], 0
   adc [CSA_EMC_dNumer+MMSB], 0

; Compute the division of numerator divided by denominator
   asl [CSA_EMC_dNumer+LLSB]
   rlc [CSA_EMC_dNumer+LMSB]
   rlc [CSA_EMC_dNumer+MLSB]
   rlc [CSA_EMC_dNumer+MMSB]
   mov X, 16
.DivideLoop:
; Subtract the divisor or denominator from the MMSB MLSB dividend or numerator
   mov A, [CSA_EMC_wDenom+LSB]
   sub [CSA_EMC_dNumer+MLSB], A
   mov A, [CSA_EMC_wDenom+MSB]
   sbb [CSA_EMC_dNumer+MMSB], A
; Check if less than zero
   jnc .SetLSbToOneAndShift
.AddBackSetLSbToZeroAndShift:
; Less than zero so add back to dividend and shift a zero into the dividend
   mov A, [CSA_EMC_wDenom+LSB]
   add [CSA_EMC_dNumer+MLSB], A
   mov A, [CSA_EMC_wDenom+MSB]
   adc [CSA_EMC_dNumer+MMSB], A
   asl [CSA_EMC_dNumer+LLSB]
   rlc [CSA_EMC_dNumer+LMSB]
   rlc [CSA_EMC_dNumer+MLSB]
   rlc [CSA_EMC_dNumer+MMSB]
   dec X
   jnz .DivideLoop
   jmp .EndOfDivide
.SetLSbToOneAndShift:
   asl [CSA_EMC_dNumer+LLSB]
   or [CSA_EMC_dNumer+LLSB], 0x01
   rlc [CSA_EMC_dNumer+LMSB]
   rlc [CSA_EMC_dNumer+MLSB]
   rlc [CSA_EMC_dNumer+MMSB]
   dec X
   jnz .DivideLoop
.EndOfDivide:
; MMSB and MLSB have carry after shifted right once
   rrc [CSA_EMC_dNumer+MMSB]
   rrc [CSA_EMC_dNumer+MLSB]
; Load return value
   mov X, [CSA_EMC_wCtrdPos+MSB]
   mov A, [CSA_EMC_wCtrdPos+LSB]
   jmp .EndGetCtrdPos
.COM_Error:
; Load error return value
   mov A, 0xff
   mov X, 0xff
.EndGetCtrdPos:
; Algorithm is finished, position is in [CSA_EMC_wCtrdPos]
   RAM_EPILOGUE RAM_USE_CLASS_3
   ret

; Multiplication algorithm (for whole numbers)
.MultiplyNumeratorWhole:
   mov A, 0x01
.CheckToAddNext2xLSB:
   push A
   and A, [CSA_EMC_wDivBtwSns+LSB] ; See if current 2^x needs added
   jz .SkipAddAndShiftLeftLSB
   mov A, [CSA_EMC_dMultTempX+LLSB]
   add [CSA_EMC_dNumer+LLSB], A
   mov A, [CSA_EMC_dMultTempX+LMSB]
   adc [CSA_EMC_dNumer+LMSB], A
   mov A, [CSA_EMC_dMultTempX+MLSB]
   adc [CSA_EMC_dNumer+MLSB], A
   mov A, [CSA_EMC_dMultTempX+MMSB]
   adc [CSA_EMC_dNumer+MMSB], A
.SkipAddAndShiftLeftLSB:
   asl [CSA_EMC_dMultTempX+LLSB]
   rlc [CSA_EMC_dMultTempX+LMSB]
   rlc [CSA_EMC_dMultTempX+MLSB]
   rlc [CSA_EMC_dMultTempX+MMSB]
   pop A
   asl A
   jnc .CheckToAddNext2xLSB
   mov A, [CSA_EMC_wDivBtwSns+MSB]
   jz .EndMultiplyNumeratorWhole ; only multiply by MSB if needed
   mov A, 0x01
.CheckToAddNext2xMSB:
   push A
   and A, [CSA_EMC_wDivBtwSns+MSB] ; See if current 2^x needs added
   jz .SkipAddAndShiftLeftMSB
   mov A, [CSA_EMC_dMultTempX+LLSB]
   add [CSA_EMC_dNumer+LLSB], A
   mov A, [CSA_EMC_dMultTempX+LMSB]
   adc [CSA_EMC_dNumer+LMSB], A
   mov A, [CSA_EMC_dMultTempX+MLSB]
   adc [CSA_EMC_dNumer+MLSB], A
   mov A, [CSA_EMC_dMultTempX+MMSB]
   adc [CSA_EMC_dNumer+MMSB], A
.SkipAddAndShiftLeftMSB:
   asl [CSA_EMC_dMultTempX+LLSB]
   rlc [CSA_EMC_dMultTempX+LMSB]
   rlc [CSA_EMC_dMultTempX+MLSB]
   rlc [CSA_EMC_dMultTempX+MMSB]
   pop A
   asl A
   jnc .CheckToAddNext2xMSB
.EndMultiplyNumeratorWhole:
   ret

; Multiplication algorithm (for fractional numbers)
.MultiplyNumeratorFraction:
   and F, ~0x04 ; clear carry bit if set
   rrc [CSA_EMC_dMultTempY+MMSB]
   rrc [CSA_EMC_dMultTempY+MLSB]
   rrc [CSA_EMC_dMultTempY+LMSB]
   rrc [CSA_EMC_dMultTempY+LLSB]
   mov A, 0x80
.CheckToAddNextHalf:
   push A
   and A, [CSA_EMC_wDivBtwSns+LSB]
   jz .SkipAddAndShiftRight
   mov A, [CSA_EMC_dMultTempY+LLSB]
   add [CSA_EMC_dNumer+LLSB], A
   mov A, [CSA_EMC_dMultTempY+LMSB]
   adc [CSA_EMC_dNumer+LMSB], A
   mov A, [CSA_EMC_dMultTempY+MLSB]
   adc [CSA_EMC_dNumer+MLSB], A
   mov A, [CSA_EMC_dMultTempY+MMSB]
   adc [CSA_EMC_dNumer+MMSB], A
.SkipAddAndShiftRight:
   asr [CSA_EMC_dMultTempY+MMSB]
   rrc [CSA_EMC_dMultTempY+MLSB]
   rrc [CSA_EMC_dMultTempY+LMSB]
   rrc [CSA_EMC_dMultTempY+LLSB]
   pop A
   and F, ~0x04 ; clear carry bit if set
   rrc A
   jnc .CheckToAddNextHalf
   ret

.ENDSECTION

.LITERAL
CSA_EMC_SLIDER_RESOLUTION_TABLE:

.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_wGetRadialInc(BYTE bSnsGroup)
;  DESCRIPTION:
;
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;       A => Sensor Group
;       Sensor Group = 0 for the independent sensors group
;       Sensor Group = 1 for the first slider group
;       Sensor Group = 2 for the second slider group
;  RETURNS:
;      result - offset (positive or negative)  through X and A
;-----------------------------------------------------------------------------
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------

 CSA_EMC_wGetRadialInc:
_CSA_EMC_wGetRadialInc:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov [CSA_EMC_bCurCtrdSize], A  ;saves slider number
   dec [CSA_EMC_bCurCtrdSize]
   asl [CSA_EMC_bCurCtrdSize]

   mov X, [CSA_EMC_bCurCtrdSize]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   cmp [X + CSA_EMC_waSliderPrevPos + 0], FFh
   jnz .CurrCheck
   cmp [X + CSA_EMC_waSliderPrevPos + 1], FFh
   jnz .CurrCheck

   mov X, 00h
   mov A, 00h
   jmp .Done

.CurrCheck:
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   cmp [X + CSA_EMC_waSliderCurrPos + 0], FFh
   jnz .Calculations
   cmp [X + CSA_EMC_waSliderCurrPos + 1], FFh
   jnz .Calculations

   mov X, 00h
   mov A, 00h
   jmp .Done

.Calculations:
   ;getting A*6
   mov A,  [CSA_EMC_bCurCtrdSize]
   index CSA_EMC_SLIDER_RESOLUTION_TABLE
   mov [CSA_EMC_wCurPkValue + 0], A
   mov A,  [CSA_EMC_bCurCtrdSize]
   inc A
   index CSA_EMC_SLIDER_RESOLUTION_TABLE
   mov [CSA_EMC_wCurPkValue + 1], A

   ;wDenom = Resolution/2
   mov A, [CSA_EMC_wCurPkValue + 0]
   asr A
   mov [CSA_EMC_wDenom + 0], A
   mov A, [CSA_EMC_wCurPkValue + 1]
   rrc A
   mov [CSA_EMC_wDenom + 1], A

   mov X, [CSA_EMC_bCurCtrdSize]

   ;detect direction of the motion
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   sub A, [X + CSA_EMC_waSliderPrevPos + 1]
   mov [CSA_EMC_dMultTempY + 1], A

   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos + 0]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   sbb A, [X + CSA_EMC_waSliderPrevPos + 0]
   mov [CSA_EMC_dMultTempY + 0], A

   tst [CSA_EMC_dMultTempY + 0], 80h
   jnz .DiffIsNegative ;negative

   ;positive
   mov A, [CSA_EMC_dMultTempY + 0]
   cmp A, [CSA_EMC_wDenom + 0]
   jc .LessThenAHalfOfResol1
   jnz .GreaterThenAHalfOfResol1

   mov A, [CSA_EMC_dMultTempY + 1]
   cmp A, [CSA_EMC_wDenom + 1]
   jc .LessThenAHalfOfResol1
   jmp .GreaterThenAHalfOfResol1

.LessThenAHalfOfResol1:
   ;Less than a half of resolution
   mov X, [CSA_EMC_dMultTempY + 0]
   mov A, [CSA_EMC_dMultTempY + 1]
   jmp .Done

.GreaterThenAHalfOfResol1:
   mov A, [CSA_EMC_dMultTempY + 1]
   sub A, [CSA_EMC_wCurPkValue + 1]
   mov X, A
   mov A, [CSA_EMC_dMultTempY + 0]
   sbb A, [CSA_EMC_wCurPkValue + 0]
   swap A, X
   jmp .Done

.DiffIsNegative:
   mov A, [CSA_EMC_dMultTempY + 1]
   cpl A
   inc A
   mov [CSA_EMC_dMultTempX + 1], A
   mov A, [CSA_EMC_dMultTempY + 0]
   cpl A
   adc A, 0

   cmp A, [CSA_EMC_wDenom + 0]
   jc .LessThenAHalfOfResol2
   jnz .GreaterThenAHalfOfResol2

   mov A, [CSA_EMC_dMultTempX + 1]
   cmp A, [CSA_EMC_wDenom + 1]
   jc .LessThenAHalfOfResol2
   jmp .GreaterThenAHalfOfResol2

.LessThenAHalfOfResol2:  ;!!!!!!need optimization
   ;Less than a half of resolution
   mov X, [CSA_EMC_dMultTempY + 0]
   mov A, [CSA_EMC_dMultTempY + 1]
   jmp .Done

.GreaterThenAHalfOfResol2:
   mov A, [CSA_EMC_dMultTempY + 1]
   add [CSA_EMC_wCurPkValue + 1], A
   mov A, [CSA_EMC_dMultTempY + 0]
   adc [CSA_EMC_wCurPkValue + 0], A
   mov X, [CSA_EMC_wCurPkValue + 0]
   mov A, [CSA_EMC_wCurPkValue + 1]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.LITERAL
CSA_EMC_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE:
IF (1h)
  dw 1h * 256 / 1h
ENDIF 
 
IF (1h)
  dw 1h * 256 / 1h
ENDIF  

IF (1h)
  dw 1h * 256 / 1h
ENDIF  

IF (1h)
  dw 1h * 256 / 1h
ENDIF  

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF

IF (1h)
  dw 1h * 256 / 1h
ENDIF
.ENDLITERAL

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_wGetRadialPos(BYTE bSnsGroup)
;  DESCRIPTION:
;      The function finds and returns the position of the centroid in the
;      difference array.
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;       A => Sensor Group
;       Sensor Group = 0 for the independent sensors group
;       Sensor Group = 1 for the first slider group
;       Sensor Group = 2 for the second slider group
;  RETURNS:
;      result - centroid position (through X and A)
;-----------------------------------------------------------------------------
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;-----------------------------------------------------------------------------

 CSA_EMC_wGetRadialPos:
_CSA_EMC_wGetRadialPos:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   mov [CSA_EMC_bCurCtrdSize], A  ;saves slider number
   dec [CSA_EMC_bCurCtrdSize]
   asl [CSA_EMC_bCurCtrdSize]

   ;getting A*6
   asl   A       ; A*2
   mov  [CSA_EMC_bCurSlider], A ;temporary saving A*2
   asl   A       ;A*4
   add  [CSA_EMC_bCurSlider], A ;A*6
   mov  A, [CSA_EMC_bCurSlider] ;now A points on bSnsgroup offset in Group table
   index CSA_EMC_Group_Table
   mov [CSA_EMC_bStartIndex], A ;getting desired slider offset for waSnsDiff array
   mov [CSA_EMC_bEndOfArray], A
   mov  A, [CSA_EMC_bCurSlider]
   inc A
   index CSA_EMC_Group_Table
   add [CSA_EMC_bEndOfArray], A ;getting final index in waSnsDiff for desired slider

   mov A, [CSA_EMC_bCurCtrdSize]
   index CSA_EMC_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE
   mov [CSA_EMC_wCurPkValue + 0], A
   mov A, [CSA_EMC_bCurCtrdSize]
   inc A
   index CSA_EMC_RADIAL_SLIDER_RESOLUTION_MULTIPLIER_TABLE
   mov [CSA_EMC_wCurPkValue + 1], A

   asl [CSA_EMC_bEndOfArray]    ;*2 because we operating with WORDs
   asl [CSA_EMC_bStartIndex]    ;*2 because we operating with WORDs
   sub [CSA_EMC_bEndOfArray], 2 ;now it points on the last element

   ;These two variables contain required maximum
   mov [CSA_EMC_bBiggestCtrdSize], 0        ;MSB
   mov [CSA_EMC_bBiggestCtrdStartPos], 0    ;LSB

   mov [CSA_EMC_bCurPos], 0                 ;this variable saves maximum position
   mov X, [CSA_EMC_bStartIndex]             ;X - current position; access  will be performed through X (base+offset)

.IdentifyCtrd:
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   mov A, [X + CSA_EMC_waSnsDiff]
   jnz .CheckIfMaximum
   mov A, [X + CSA_EMC_waSnsDiff + 1]
   jnz .DiffIsNotZero

;Difference is zero:
   jmp .CheckNextSensor

.DiffIsNotZero:
   push X
   mov A, X
   asr A
   mov X, A
   RAM_SETPAGE_IDX >CSA_EMC_baBtnFThreshold
   mov A, [X + CSA_EMC_baBtnFThreshold]
   pop X
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff
   cmp A, [X + CSA_EMC_waSnsDiff + 1] ;Compare With FThreshold
   jnc .CheckNextSensor
   jz .CheckNextSensor

;waSnsDiff is greater than threshold
.CheckIfMaximum:
   ;Compare MSBs
   mov A, [X + CSA_EMC_waSnsDiff]
   cmp A, [CSA_EMC_bBiggestCtrdSize]
   jc .CheckNextSensor
   jnz .StoreNewMaximum

   ;Compare LSBs
   mov A, [X + CSA_EMC_waSnsDiff + 1]
   cmp A, [CSA_EMC_bBiggestCtrdStartPos]
   jc .CheckNextSensor
   jz .CheckNextSensor

;waSnsDiff is greater then stored maximum; saving new maximum
.StoreNewMaximum:
   mov A, [X + CSA_EMC_waSnsDiff]
   mov [CSA_EMC_bBiggestCtrdSize], A
   mov A, [X + CSA_EMC_waSnsDiff + 1]
   mov [CSA_EMC_bBiggestCtrdStartPos], A
   mov [CSA_EMC_bCurPos], X ;this is a new maximum position

; Find out the next position
.CheckNextSensor:
   inc X
   inc X
   mov A, X
   cmp A, [CSA_EMC_bEndOfArray] ; Check for the end of the array
   jc .IdentifyCtrd
   jz .IdentifyCtrd

;---------Centroid calculation---------

   ;if there is no finger touch then return FFFFh
   mov A, [CSA_EMC_bBiggestCtrdSize]
   jnz .FillCentroidArray

   mov A, [CSA_EMC_bBiggestCtrdStartPos]
   jnz .FillCentroidArray

   ;There was no finger present: return FFFFh value through X, A
   ;and save the same in CSA_EMC_waSliderCurrPos
   mov X, [CSA_EMC_bCurCtrdSize]

   ;Copy CSA_EMC_waSliderCurrPos to CSA_EMC_waSliderPrevPos
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   mov [X + CSA_EMC_waSliderPrevPos], A
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   mov [X + CSA_EMC_waSliderPrevPos + 1], A

   ;set CSA_EMC_waSliderCurrPos to FFFFh
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov [X + CSA_EMC_waSliderCurrPos], FFh
   mov [X + CSA_EMC_waSliderCurrPos + 1], FFh

.SetResultToFFFFh:
   mov A, FFh
   mov X, FFh
   jmp .Done

.FillCentroidArray:
   ;There was a finger present
   ;Fill waCentroid array with elements : centroid and its left and right adjacent values
   RAM_SETPAGE_IDX >CSA_EMC_waSnsDiff

   ;waCentroid[3] - array of three values: left adjacent, centroid, right adjacent
   ;waCentroid + 0  MSB of left adjacent
   ;waCentroid + 1  LSB of left adjacent
   ;waCentroid + 2  MSB of centroid
   ;waCentroid + 3  LSB of centroid
   ;waCentroid + 4  MSB of right adjacent
   ;waCentroid + 5  LSB of right adjacent

   ;1) left adjacent
   mov A, [CSA_EMC_bCurPos]
   cmp A, [CSA_EMC_bStartIndex]
   jnz .CentriodIsNotInFirstPos

   ;Centroid is at first position
   mov X, [CSA_EMC_bEndOfArray] ;left adjacent(i-1)
   jmp .CopyingLeft

.CentriodIsNotInFirstPos:
   mov X, [CSA_EMC_bCurPos] ;left adjacent(i-1)
   dec X
   dec X

.CopyingLeft:
   mov A, [X + CSA_EMC_waSnsDiff + LSB]
   mov [CSA_EMC_waCentroid + 1], A
   mov A, [X + CSA_EMC_waSnsDiff + MSB]
   mov [CSA_EMC_waCentroid + 0], A

   ;2) Maximum
   mov X, [CSA_EMC_bCurPos] ;maximum(i)

.CopyingMaximum:
   mov A, [X + CSA_EMC_waSnsDiff + LSB]
   mov [CSA_EMC_waCentroid + 3], A
   mov A, [X + CSA_EMC_waSnsDiff + MSB]
   mov [CSA_EMC_waCentroid + 2], A

   ;3) right adjacent
   mov A, [CSA_EMC_bCurPos]
   cmp A, [CSA_EMC_bEndOfArray]
   jnz .CentriodIsNotInLastPos

   ;Centroid is at last position
   mov X, [CSA_EMC_bStartIndex] ;right adjacent(i+1)
   jmp .CopyingRight

.CentriodIsNotInLastPos:
   mov X, [CSA_EMC_bCurPos] ;right adjacent(i+1)
   inc X
   inc X

.CopyingRight:
   mov A, [X + CSA_EMC_waSnsDiff + LSB]
   mov [CSA_EMC_waCentroid + 5], A
   mov A, [X + CSA_EMC_waSnsDiff + MSB]
   mov [CSA_EMC_waCentroid + 4], A

   mov A, [CSA_EMC_bNoiseThreshold]
.SubstractNoise0:
   sub [CSA_EMC_waCentroid + 1], A
   sbb [CSA_EMC_waCentroid + 0], 0
   jnc .SubstractNoise1

   mov [CSA_EMC_waCentroid + 1], 0
   mov [CSA_EMC_waCentroid + 0], 0

.SubstractNoise1:
   sub [CSA_EMC_waCentroid + 3], A
   sbb [CSA_EMC_waCentroid + 2], 0
   jnc .SubstractNoise2

   mov [CSA_EMC_waCentroid + 3], 0
   mov [CSA_EMC_waCentroid + 2], 0

.SubstractNoise2:
   sub [CSA_EMC_waCentroid + 5], A
   sbb [CSA_EMC_waCentroid + 4], 0
   jnc .RestoreX

   mov [CSA_EMC_waCentroid + 5], 0
   mov [CSA_EMC_waCentroid + 4], 0

.RestoreX:
   mov X, [CSA_EMC_bCurPos]

   call CalcCentroid
   ;result is now in dMultTempY variable

   mov X, [CSA_EMC_bCurCtrdSize]

   ;there was finger presence before (during last function call)
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   mov [X + CSA_EMC_waSliderPrevPos], A
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov A, [X + CSA_EMC_waSliderCurrPos + 1]
   RAM_SETPAGE_IDX >CSA_EMC_waSliderPrevPos
   mov [X + CSA_EMC_waSliderPrevPos + 1], A

   mov A, [CSA_EMC_dMultTempY + 0];MSB of result
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov [X + CSA_EMC_waSliderCurrPos], A

   mov A, [CSA_EMC_dMultTempY + 1];LSB of result
   RAM_SETPAGE_IDX >CSA_EMC_waSliderCurrPos
   mov [X + CSA_EMC_waSliderCurrPos + 1], A

   mov X, [CSA_EMC_dMultTempY + 0]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_3
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: void CalcCentroid(WORD result)
;  DESCRIPTION:
;    Calculates touch position using centroid algorithm basing on 3 signals
;    (local maximum and adjacent)
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;    None, signal values are taken from waCentroid global array
;  RETURNS:
;   calculated touch position
;-----------------------------------------------------------------------------
 CalcCentroid:
_CalcCentroid:
   ;Zeroing
   mov   A, 0
   mov   [CSA_EMC_dMultTempX + 0], A
   mov   [CSA_EMC_dMultTempX + 1], A
   mov   [CSA_EMC_dMultTempX + 3], A
   mov   [CSA_EMC_wDenom + 0], A

   ;---calculate denominator: (i- 1 ) + i + (i+1)
   mov   A, [CSA_EMC_waCentroid + 1]                 ;LSB(i-1)
   add   A, [CSA_EMC_waCentroid + 3]                 ;add LSB(i)
   adc   [CSA_EMC_wDenom + 0], 0                     ;save carry
   add   A, [CSA_EMC_waCentroid + 5]                 ;add LSB(i + 1)
   adc   [CSA_EMC_wDenom + 0], 0                     ;save carry
   mov   [CSA_EMC_wDenom + 1], A                     ;save result

   mov   A, [CSA_EMC_waCentroid + 0]                 ;MSB(i-1)
   add   A, [CSA_EMC_waCentroid + 2]                 ;add MSB(i)
   add   A, [CSA_EMC_waCentroid + 4]                 ;add MSB(i + 1)
   add   [CSA_EMC_wDenom + 0], A                     ;save result

   ;----- calculate numerator (i+1) - (i-1)
   mov   A, [CSA_EMC_waCentroid + 5]                 ;LSB(i+1)
   sub   A, [CSA_EMC_waCentroid + 1]                 ;sub LSB(i-1)
   sbb   [CSA_EMC_dMultTempX + 1], 0                 ;save borrow
   mov   [CSA_EMC_dMultTempX + 2], A                 ;save result

   mov   A, [CSA_EMC_waCentroid + 4]                 ;MSB(i+1)
   sub   A, [CSA_EMC_waCentroid + 0]                 ;sub MSB(i-1)
   add   [CSA_EMC_dMultTempX + 1], A                 ;save result

   call  CSA_EMC_div_24_16_24                        ; calculate Sum(Si*i)/Sum(Si)
   mov   A, X
   sub   A, [CSA_EMC_bStartIndex]
   asr   A
   add   [CSA_EMC_dMultTempX + 2], A                 ;

   tst   [CSA_EMC_dMultTempX + 2], 80h
   jz .Mult

   mov   A, [CSA_EMC_bEndOfArray]
   sub   A, [CSA_EMC_bStartIndex]
   asr   A
   inc   A
   add   [CSA_EMC_dMultTempX + 2], A                 ;

.Mult:
   call  CSA_EMC_mul_16x16_32                       ; dMultTempY contains calculated coordinate (two MSB)

   mov    A, [CSA_EMC_dMultTempY]                    ; Returns result through X an d A
   mov    X, A
   mov    A, [CSA_EMC_dMultTempY+1]

   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_div_24_16_24
;  DESCRIPTION:
;  Applies 24-bit signed result of 24-bit signed operands division
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;   (MSB)[dMultTempX+1][dMultTempX+2][dMultTempX+3](LSB) - first 24-bit signed operand of division
;                                    (dividend)
;   (MSB)[wDenom][wDenom+1](LSB) - second 16-bit unsigned operand of division
;                                     (divisor)
;  RETURNS:   (MSB)[dMultTempX+1][dMultTempX+2][dMultTempX+3](LSB) - 24-bit signed operand of division
;                                    (dividend)
;-----------------------------------------------------------------------------
 CSA_EMC_div_24_16_24:
_CSA_EMC_div_24_16_24:
    mov   A,0xFF
    cmp   [CSA_EMC_dMultTempX + 1],0x80
    jc    .L1                         ;check sign of operand 1
    xor   [CSA_EMC_dMultTempX + 3],A            ;unsigned convertation of operand 1 (inversion + 1)
    inc   [CSA_EMC_dMultTempX + 3]
    xor   [CSA_EMC_dMultTempX + 2],A
    adc   [CSA_EMC_dMultTempX + 2],0x00
    xor   [CSA_EMC_dMultTempX + 1],A
    adc   [CSA_EMC_dMultTempX + 1],0x00
    mov   [CSA_EMC_dMultTempX + 0], A

.L1:
    mov   A,0x00
    mov   [CSA_EMC_dMultTempY + 0],A  ;additional temporary memory for calculations
    mov   [CSA_EMC_dMultTempY + 1],A
    mov   [CSA_EMC_dMultTempY + 2],A
    mov   [CSA_EMC_dMultTempY + 3],A

    mov   [CSA_EMC_bCurPkPos], 24          ;amount of cycles divider procedure

	;Begin of divider procedure
j4_1:
    asl   [CSA_EMC_dMultTempX + 3]
    rlc   [CSA_EMC_dMultTempX + 2]
    rlc   [CSA_EMC_dMultTempX + 1]

    rlc   [CSA_EMC_dMultTempY + 3]
    rlc   [CSA_EMC_dMultTempY + 2]
    rlc   [CSA_EMC_dMultTempY + 1]

    mov   A,[CSA_EMC_dMultTempY + 3]
    sbb   A,[CSA_EMC_wDenom + 1]
    mov   A,[CSA_EMC_dMultTempY + 2]
    sbb   A,[CSA_EMC_wDenom + 0]
    mov   A,[CSA_EMC_dMultTempY + 1]
    sbb   A, 0
    jc    j4_2
    mov   [CSA_EMC_dMultTempY + 1],A
    mov   A,[CSA_EMC_wDenom + 1]
    sub   [CSA_EMC_dMultTempY + 3],A
    mov   A,[CSA_EMC_wDenom + 0]
    sbb   [CSA_EMC_dMultTempY + 2],A
    inc   [CSA_EMC_dMultTempX + 3]
j4_2:
    dec   [CSA_EMC_bCurPkPos]
    jnz   j4_1

    ;End of divider procedure
   mov    A, 0xFF
   cmp   [CSA_EMC_dMultTempX + 0],0x80
   jc    .L2                         ;check sign of result
   xor   [CSA_EMC_dMultTempX + 3],A            ;unsigned convertation of operand 1
   inc   [CSA_EMC_dMultTempX + 3]
   xor   [CSA_EMC_dMultTempX + 2],A
   adc   [CSA_EMC_dMultTempX + 2],0x00
   xor   [CSA_EMC_dMultTempX + 1],A
   adc   [CSA_EMC_dMultTempX + 1],0x00
   xor   [CSA_EMC_dMultTempX + 0],A
.L2:

   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FRAGMENT NAME: CSA_EMC_mul_16x16_32
;  DESCRIPTION:
;      Ancillary fragment for integer fastcall16 functions. Applies 32-bit
;      unsigned result of two 16-bit unsigned operands multiplication
;-----------------------------------------------------------------------------
;  ARGUMENTS:
;      (MSB)[dMultTempX+2][dMultTempX+3](LSB) - 16-bit unsigned multiplier (first operand)
;     wCurPkValue - 16-bit unsigned multiplicand (second operand)
;  RETURNS:
;      (MSB)[dMultTempY][dMultTempY+1][wCurPkValue + 0][wCurPkValue + 1](LSB) - 32-bit unsigned multiplication result
;-----------------------------------------------------------------------------
 CSA_EMC_mul_16x16_32:
_CSA_EMC_mul_16x16_32:
   mov   A,0x00
   mov   [CSA_EMC_dMultTempY + 0],A              ; clear LSB of result
   mov   [CSA_EMC_dMultTempY + 1],A              ; clear MSB of result

   add   A,0x10                                            ;clear CARRY-bit and
   mov   [CSA_EMC_bCurPkPos],A                   ;init loop counter

.jLab2:
   tst   [CSA_EMC_wCurPkValue + 1],0x01
   jz    .jLab1
   mov   A,[CSA_EMC_dMultTempX+3]                ;if [wTmp2+LSB].0=1 then result+=first operand
   add   [CSA_EMC_dMultTempY+1],A
   mov   A,[CSA_EMC_dMultTempX+2]
   adc   [CSA_EMC_dMultTempY],A
.jLab1:
   rrc   [CSA_EMC_dMultTempY]                    ; 1-bit right shift of second operand
   rrc   [CSA_EMC_dMultTempY+1]
   rrc   [CSA_EMC_wCurPkValue + 0]               ; 1-bit left shift of first operand
   rrc   [CSA_EMC_wCurPkValue + 1]
   dec   [CSA_EMC_bCurPkPos]                     ; decrement loop counter
   jnz   .jLab2

   ret
.ENDSECTION
ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_MedianFilter(void)
;
;  DESCRIPTION:
;      Applies a midian filter to 3 input values
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      None. Input values are CSA_EMC_wX1, CSA_EMC_wX2 and CSA_EMC_wX3
;
;  RETURNS:
;      Nothing. Relult is in CSA_EMC_wX1
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
MedianFilter:
 CSA_EMC_MedianFilter:
_CSA_EMC_MedianFilter:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   A, [CSA_EMC_wX1+LSB]                    ; if X1 > X2
   cmp   A, [CSA_EMC_wX2+LSB]
   mov   A, [CSA_EMC_wX1+MSB]
   sbb   A, [CSA_EMC_wX2+MSB]
   jc    .L1

   mov   A, [CSA_EMC_wX1+LSB]                    ; then  X1 <--> X2
   swap  A, [CSA_EMC_wX2+LSB]
   mov   [CSA_EMC_wX1+LSB], A
   mov   A, [CSA_EMC_wX1+MSB]
   swap  A, [CSA_EMC_wX2+MSB]
   mov   [CSA_EMC_wX1+MSB], A

.L1:
   mov   A, [CSA_EMC_wX2+LSB]                    ; if X2 > X3
   cmp   A, [CSA_EMC_wX3+LSB]
   mov   A, [CSA_EMC_wX2+MSB]
   sbb   A, [CSA_EMC_wX3+MSB]
   jc    .L2

   mov   [CSA_EMC_wX2+LSB], [CSA_EMC_wX3+LSB]    ; then  X2 := X3
   mov   [CSA_EMC_wX2+MSB], [CSA_EMC_wX3+MSB]

.L2:
   mov   A, [CSA_EMC_wX1+LSB]                    ; if X1 > X2
   cmp   A, [CSA_EMC_wX2+LSB]
   mov   A, [CSA_EMC_wX1+MSB]
   sbb   A, [CSA_EMC_wX2+MSB]
   jnc   .Done                                      ; then  result is in X1

   mov   [CSA_EMC_wX1+LSB], [CSA_EMC_wX2+LSB]    ; else  X1 := X2
   mov   [CSA_EMC_wX1+MSB], [CSA_EMC_wX2+MSB]

.Done:
   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

IF (CSA_EMC_RAW_IIR_ENABLE)
.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_IIRFilter(void)
;
;  DESCRIPTION:
;      Applies an IIR filter to input values
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;      None. Input values are CSA_EMC_wADCResult (new) andCSA_EMC_wX1 (old)
;
;  RETURNS:
;      Nothing. Relult is in CSA_EMC_wADCResult
;
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_IIRFilter:
_CSA_EMC_IIRFilter:
   RAM_PROLOGUE RAM_USE_CLASS_4
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area

   mov   A, [CSA_EMC_wX1 + LSB]                  ; x[n+1]-y[n]
   sub   [CSA_EMC_wADCResult + LSB], A
   mov   A, [CSA_EMC_wX1 + MSB]
   sbb   [CSA_EMC_wADCResult + MSB], A

   mov   A, CSA_EMC_RAW_IIR_COEFF/2
.M:
   asr   [CSA_EMC_wADCResult + MSB]              ; (x[n+1]-y[n]) / Coef
   rrc   [CSA_EMC_wADCResult + LSB]
   dec   A
   jnz   .M

   mov   A, [CSA_EMC_wADCResult + LSB]           ; y[n+1] = y[n] + (x[n+1]-y[n]) / Coef
   add   A, [CSA_EMC_wX1 + LSB]
   mov   [CSA_EMC_wADCResult + LSB], A
   mov   [CSA_EMC_wX1 + LSB], A
   mov   A, [CSA_EMC_wADCResult + MSB]
   adc   A, [CSA_EMC_wX1 + MSB]
   mov   [CSA_EMC_wADCResult + MSB], A
   mov   [CSA_EMC_wX1 + MSB], A

   RAM_EPILOGUE RAM_USE_CLASS_4
   ret
.ENDSECTION

ENDIF

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: CSA_EMC_ProcessData(void)
;
;  DESCRIPTION:
;    Scans all sensors to find their raw count values
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      None
;  SIDE EFFECTS:
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16
;    functions.
;
 CSA_EMC_ProcessData:
_CSA_EMC_ProcessData:
   RAM_PROLOGUE RAM_USE_CLASS_3
   RAM_SETPAGE_CUR 0 ; direct access ram will always be in interrupt ram area
   mov   X, A

IF (CSA_EMC_RAW_MEDIAN_ENABLE | CSA_EMC_RAW_IIR_ENABLE)
ELSE
   ; Store the data
   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   A, [CSA_EMC_wADCResult+LSB]
   mov   [X+CSA_EMC_waSnsResult+LSB], A
   mov   A, [CSA_EMC_wADCResult+MSB]
   mov   [X+CSA_EMC_waSnsResult+MSB], A
ENDIF

IF (CSA_EMC_RAW_MEDIAN_ENABLE)
   mov   [CSA_EMC_wX1+LSB], [CSA_EMC_wADCResult+LSB]
   mov   [CSA_EMC_wX1+MSB], [CSA_EMC_wADCResult+MSB]

   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   A, [X+CSA_EMC_waSnsResult+LSB]
   mov   [CSA_EMC_wX2+LSB], A
   mov   A, [X+CSA_EMC_waSnsResult+MSB]
   mov   [CSA_EMC_wX2+MSB], A

   RAM_SETPAGE_IDX >CSA_EMC_waRaw2
   mov   A, [X+CSA_EMC_waRaw2+LSB]
   mov   [CSA_EMC_wX3+LSB], A
   mov   A, [X+CSA_EMC_waRaw2+MSB]
   mov   [CSA_EMC_wX3+MSB], A
   call  CSA_EMC_MedianFilter

   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   A, [X+CSA_EMC_waSnsResult+LSB]
   RAM_SETPAGE_IDX >CSA_EMC_waRaw2
   mov   [X+CSA_EMC_waRaw2+LSB], A
   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   A, [X+CSA_EMC_waSnsResult+MSB]
   RAM_SETPAGE_IDX >CSA_EMC_waRaw2
   mov   [X+CSA_EMC_waRaw2+MSB], A

   RAM_SETPAGE_IDX >CSA_EMC_waSnsResult
   mov   A, [CSA_EMC_wADCResult+LSB]
   mov   [X+CSA_EMC_waSnsResult+LSB], A
   mov   A, [CSA_EMC_wADCResult+MSB]
   mov   [X+CSA_EMC_waSnsResult+MSB], A

   mov   [CSA_EMC_wADCResult+LSB], [CSA_EMC_wX1+LSB]
   mov   [CSA_EMC_wADCResult+MSB], [CSA_EMC_wX1+MSB]
ENDIF

IF (CSA_EMC_RAW_IIR_ENABLE)
   RAM_SETPAGE_IDX >CSA_EMC_waIIR
   mov   A, [X+CSA_EMC_waIIR+LSB]
   mov   [CSA_EMC_wX1+LSB], A
   mov   A, [X+CSA_EMC_waIIR+MSB]
   mov   [CSA_EMC_wX1+MSB], A

   call  CSA_EMC_IIRFilter

   mov   A, [CSA_EMC_wADCResult+LSB]
   mov   [X+CSA_EMC_waIIR+LSB], A
   mov   A, [CSA_EMC_wADCResult+MSB]
   mov   [X+CSA_EMC_waIIR+MSB], A
ENDIF
   mov   A, X
   lcall CSA_EMC_UpdateBaseline

   RAM_EPILOGUE RAM_USE_CLASS_3
   ret
.ENDSECTION
